(***************************************************************************)
(**                            UNIT BOXMAIN.PAS                           **)
(***************************************************************************)
(**  Groe Mailbox-Hauptroutine. Hier 'rber geht alles, was in die       **)
(**  Mailbox will.                                                        **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
UNIT BoxMain;

INTERFACE

  {Guckt im Import-Verzeichnis, ob Mails vorhanden sind}
  PROCEDURE Box_NewMail;

  {Wird aufgerufen, wenn eine Station die Mailbox neu connected.
   Hier wird nach dem Passwort geguckt}
  PROCEDURE Box_Login(c:BYTE);

  {Auch eine Login-Prozedur, allerdings wird hier NICHT nach dem Passwort
   gefragt. (Wenns richtig beantwortet wurde)}
  PROCEDURE BoxLoginOhnePasswd(c: BYTE);

  {Wird aufgerufen, wenn ein User disconnected wird}
  PROCEDURE Box_Disc(C:BYTE);

  {Mailbox Haupt-Routine}
  PROCEDURE HandleBox(c:BYTE;s:STRING);

  {Nix}
  PROCEDURE GetMailStart(C:BYTE;filename:string;header:BOOLEAN);
  FUNCTION  GetMailData(C:BYTE;var DATA:STRING):BOOLEAN;

  {Guckt nach, ob s&f gepollt werden soll oder nicht}
  PROCEDURE Auto_SF_Poll;

  {Sagt der Name eigentlich schon}
  PROCEDURE Box_Send_Queue;



IMPLEMENTATION

USES IADVAR,
     MCUTREM,
     MCUTLIB2,
     BOXUTIL,
     TOOLBOX,
     BOXHUSER,
     BOXCMD,
     BOXOCMD,
     BOXSEND,
     BOXGARB,
     BOXVARS,
     BOXSF,
     BOXSFFBB,
     BOXIMP,
     BOXHELP,
     {$IFDEF CONVERS}
     CONVERS,
     {$ENDIF}
     {$IFDEF WA8DED}
     TNC,
     {$ENDIF}
     {$IFDEF FLEXNET}
     FLXAPP,
     {$ENDIF}
     CRT,
     DOS;


{Box-CText schicken}
PROCEDURE SendBoxCText(c: BYTE);
VAR f: Text;
    S,S1,Hlp: STRING;
    aword: WORD;
    DT: DateTime;
    OK: BOOLEAN;
    SR:SearchRec;
BEGIN
  IF KS[c]^.BoxData^.HelpLevel<=1 THEN
    ASSIGN(f,BoxPath+'msg'+PATH_SEP+'ctext.'+KS[c]^.BoxData^.Spk)
  ELSE
    ASSIGN(f,BoxPath+'msg'+PATH_SEP+'ctext_lg.'+KS[c]^.BoxData^.Spk);

  {$I-}
  RESET(f);
  {$I+}
  IF IOResult=0 THEN BEGIN
    WHILE NOT EOF(f) DO BEGIN
      READLN(f,S);
      S:=ExpandMacros(c,s);
      PutData(c,S+#13);
    END;
    CLOSE(f);
  END;
  FindFirst(boxPath+'msg'+PATH_SEP+'news.'+KS[c]^.BoxData^.Spk,anyfile,sr);
  IF DosError=0 THEN BEGIN
    IF sr.time>getLastQuit(OK,KS[c]^.call) THEN
    BEGIN
      PutData(c,'News ('+dtDateStr(sr.time)+'-'+DtTimeStr(sr.time)+'):'+#13);
      SendMacroFile(c,boxPath+'msg'+PATH_SEP+'news.'+KS[c]^.BoxData^.Spk)
    END;
  END;
  IF GetMYBBS(CutSSID(KS[c]^.Call))='' THEN PutData(c,SysText(c,65)+#13);
  IF GetName(OK,c)='' THEN PutData(c,SysText(c,64)+#13);
END;


{Testet ein eingegebenes Passwort}
PROCEDURE Passwort_Check(ch: BYTE; S: STRING);
BEGIN
  IF POS(KS[ch]^.PwData^.PwStrg,S)=0 THEN BEGIN
    DISPOSE(KS[ch]^.PwData);
    KS[ch]^.PwData := NIL;
    PutData(ch,#13+'*** Sri, wrong password'+#13);
    ProfileBox('USER-PW Fail: '+cutssid(KS[ch]^.call),PBOX_BADCALL);
    KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
    Exit;
  END;
  KS[ch]^.status := KS[ch]^.PwData^.OldStatus;
  BoxLoginOhnePasswd(ch);
  DISPOSE(KS[ch]^.PwData);
  KS[ch]^.PwData := NIL;
END;


{Fragt das Passwort fr den angegebenen User ab}
PROCEDURE PasswortAbfrage(ch: BYTE);
VAR i,Anz: BYTE;
    Passwd: STRING;
    OK: BOOLEAN;
    Hlp: STRING[5];
BEGIN
  RANDOMIZE;
  new(KS[ch]^.PwData);
  PutData(ch,#13+CutSSID(BoxCall)+'>');

  OK := GetPasswd(CutSSID(KS[ch]^.Call),Passwd);
  IF NOT OK THEN Exit;

  Anz := 0;
  KS[ch]^.PwData^.PwStrg[0] := #5;
  WHILE Anz<5 DO BEGIN
    inc(Anz);
    i := RANDOM(LENGTH(Passwd));
    WHILE i=0 DO i := RANDOM(LENGTH(Passwd));
    STR(i,Hlp);
    PutData(ch,' ' + Hlp);
    KS[ch]^.PwData^.PwStrg[Anz] := Passwd[i];
  END;
  PutData(ch,''#13);
  KS[ch]^.PwData^.OldStatus := KS[ch]^.status;  {Alten status sichern}
  KS[ch]^.status := 59;                         {Passwort-Eingabe}

END;



PROCEDURE Box_Login(c:BYTE);
VAR S: STRING;              {Temporrer String frs Passwort}
    SF_Partner: BOOLEAN;
    Pass: BOOLEAN;          {TRUE, wenn eine Datei namens <Call>.PWD
                             vorhanden ist}
    B,B2:BYTE;S2,S3:STRING[80];
    PWBFile:TEXT;

BEGIN
  if not box_is_running then
  begin
    PutData(c,'BOX is currently disabled'+#13);
    KS[c]^.FLAGS:=KS[c]^.flags OR KS_DISCREQ;
    exit;
  end;
  IF IsPasswd(CutSSID(KS[c]^.Call)) THEN BEGIN
    PasswortAbfrage(c);
    Exit;
  END;



  {Wenn die connectende Station in BADCALLS steht, wird sie hier wieder
   disconnected}
  IF IsInBadCalls(CutSSID(KS[c]^.Call)) THEN BEGIN
    ProfileBox('BADCALL tried to connect: '+cutssid(KS[c]^.call),PBOX_BADCALL);
    KS[c]^.FLAGS := KS[c]^.FLAGS OR KS_DISCREQ;
    Exit;
  END;


  new(KS[c]^.BoxData);
  KS[c]^.BoxData^.spk := GetSpk(c);
  {alten Status sichern}
  KS[c]^.BoxData^.oldStatus := KS[c]^.status;
  IF KS[c]^.status = 50 THEN KS[c]^.BoxData^.oldStatus := -1;
  KS[c]^.status:=50;
  KS[c]^.BoxData^.LoginTime := CurrIxTime;
  KS[c]^.BoxData^.LastSendTime := CurrIxTime;
  KS[c]^.BoxData^.Proto := FALSE;
  KS[c]^.BoxData^.FirstBoxRead := NIL;
  KS[c]^.BoxData^.SendData := NIL;
  KS[c]^.BoxData^.CmdQueue := NIL;
  KS[c]^.BoxData^.CheckAusgabe := NIL;
  KS[c]^.Boxdata^.PW := FALSE;
  KS[c]^.BoxData^.M_Sender := '';
  KS[c]^.BoxData^.M_Titel := '';
  KS[c]^.BoxData^.M_Verteil := '';


  SF_Partner := SF_User(CutSSID(KS[c]^.Call));
  Pass := SF_Passwort(CutSSID(KS[c]^.Call));
  KS[c]^.BoxData^.SF_PW := Pass;


  IF SF_Partner OR OwnBoxData^.SF_Mit_Jedem THEN BEGIN
    CASE What_SID(CutSSID(KS[c]^.Call)) OF
      1: PutData(c,SID);
      2: PutData(c,THEBOX_SID);
      ELSE PutData(c,SID);
    END;
    (* DieBox S&F-Passwort.... *)

    IF Pass THEN PutData(c,' '+PasswdTime_CalcPW(c)+#13)
    ELSE
      IF NOT fileda(boxpath+klein(cutssid(ks[c]^.Call))+'.pwb') THEN
	 PutData(c,#13)
      ELSE	 
      BEGIN
        (* IAD, sept 96: BCM-S&F-Passwort *)
        ASSIGN(PWBFIle,boxpath+klein(cutssid(ks[c]^.Call))+'.pwb');
        {$I-}
        Reset(PwbFile);
        IF IORESULT=0 THEN
        BEGIN
          READLN(PWBFile,s3);
          CLOSE(PWBFile);
          FOR B:=1 TO 5 DO
          BEGIN
            b2:=random(Length(s3)-1)+1;
            KS[c]^.BoxData^.SF_PW_What[b]:=s3[b2];
            Str(b2,s2);
            PutData(c,' '+s2);
          END;
          KS[c]^.BoxData^.SF_PW_What[0]:=#5;
          KS[c]^.BoxData^.SF_PW:=TRUE;
        END;
        PutData(c,#13);
      END;
  END;

  {Wenn die Station in BOX.SF steht, gibt's ein S&F-Prompt ohne C-Text}
  IF SF_Partner THEN BEGIN
    PutData(c,'>'#13);
    {Variablen vorbesetzen}
    KS[c]^.BoxData^.status := 0;          {status: Auf befehle warten}
    KS[c]^.BoxData^.Rubrik := gross(cutssid(KS[c]^.Call));
                                        {Aktuelle Rubrik: eigene}
    KS[c]^.BoxData^.Start_SF := TRUE;
    GetBoxUser(c);
  END
  ELSE BEGIN    {Ansonsten den normalen C-Text}

    {Sprache setzen}
    GetBoxUser(c);
    {Connect-Text schicken}
    SendBoxCText(c);

    {Variablen vorbesetzen}
    KS[c]^.BoxData^.status := 0;          {status: Auf befehle warten}
    KS[c]^.BoxData^.Rubrik := gross(cutssid(KS[c]^.Call));
                                        {Aktuelle Rubrik: eigene}
    KS[c]^.BoxData^.Start_SF := FALSE;

    {Liste der Mails anzeigen}
    List(c,'',FALSE);

    {Anzahl Logins in USER.BOX um 1 erhhen}
    AddOneLogin(CutSSID(KS[c]^.Call));

    {LastLogin mit der aktuellen Zeit+Datum setzen}
    SetLogin(c);

    PutData(c,#13+BoxPrompt(c));
  END;
END;


PROCEDURE BoxLoginOhnePasswd(c: BYTE);
VAR SF_Partner: BOOLEAN;
    Pass: BOOLEAN;          {TRUE, wenn eine Datei namens <Call>.PWD
                             vorhanden ist}
    B:BYTE;S2:STRING[2];

BEGIN
  if not box_is_running then
  begin
    PutData(c,'BOX is currently disabled'+#13);
    KS[c]^.FLAGS:=KS[c]^.flags OR KS_DISCREQ;
    exit;
  end;

  {Wenn die connectende Station in BADCALLS steht, wird sie hier wieder
   disconnected}
  IF IsInBadCalls(CutSSID(KS[c]^.Call)) THEN BEGIN
    ProfileBox('BADCALL tried to connect: '+cutssid(KS[c]^.call),PBOX_BADCALL);
    KS[c]^.FLAGS := KS[c]^.FLAGS OR KS_DISCREQ;
    Exit;
  END;


  new(KS[c]^.BoxData);
  KS[c]^.BoxData^.spk := GetSpk(c);
  {alten Status sichern}
  KS[c]^.BoxData^.oldStatus := KS[c]^.status;
  IF KS[c]^.status = 50 THEN KS[c]^.BoxData^.oldStatus := -1;
  KS[c]^.status:=50;
  KS[c]^.BoxData^.LoginTime := CurrIxTime;
  KS[c]^.BoxData^.LastSendTime := CurrIxTime;
  KS[c]^.BoxData^.Proto := FALSE;
  KS[c]^.BoxData^.FirstBoxRead := NIL;
  KS[c]^.BoxData^.SendData := NIL;
  KS[c]^.BoxData^.CmdQueue := NIL;
  KS[c]^.BoxData^.CheckAusgabe := NIL;
  KS[c]^.Boxdata^.PW := TRUE;
  KS[c]^.BoxData^.M_Sender := '';
  KS[c]^.BoxData^.M_Titel := '';


  SF_Partner := SF_User(CutSSID(KS[c]^.Call));
  Pass := SF_Passwort(CutSSID(KS[c]^.Call));
  KS[c]^.BoxData^.SF_PW := Pass;

  IF SF_Partner OR OwnBoxData^.SF_Mit_Jedem THEN BEGIN
    CASE What_SID(CutSSID(KS[c]^.Call)) OF
      1: PutData(c,SID+#13);
      2: PutData(c,THEBOX_SID+#13);
      ELSE PutData(c,SID+#13);
    END;
    IF Pass THEN PutData(c,' '+PasswdTime_CalcPW(c)+#13)
      ELSE
      BEGIN
	 IF FileDa(boxpath+klein(cutssid(ks[c]^.Call))+'.pwb') THEN
        BEGIN
          FOR B:=1 TO 5 DO
          BEGIN
            Str(random(9),s2);
            PutData(c,' '+s2);
          END;
        END;
        PutData(c,#13);
      END;
  END;



  {Wenn die Station in BOX.SF steht, gibt's ein S&F-Prompt ohne C-Text}
  IF SF_Partner THEN BEGIN
    PutData(c,'>'#13);
    {Variablen vorbesetzen}
    KS[c]^.BoxData^.status := 0;          {status: Auf befehle warten}
    KS[c]^.BoxData^.Rubrik := gross(cutssid(KS[c]^.Call));
                                        {Aktuelle Rubrik: eigene}
    KS[c]^.BoxData^.Start_SF := TRUE;
    GetBoxUser(c);
  END
  ELSE BEGIN    {Ansonsten den normalen C-Text}


    {Variablen vorbesetzen}
    KS[c]^.BoxData^.status := 0;          {status: Auf befehle warten}
    KS[c]^.BoxData^.Rubrik := gross(cutssid(KS[c]^.Call));
                                        {Aktuelle Rubrik: eigene}
    KS[c]^.BoxData^.Start_SF := FALSE;
    GetBoxUser(c);

    {Connect-Text schicken}
    SendBoxCText(c);

    {Sprache setzen}
    KS[c]^.BoxData^.Spk := GetSpk(c);
    PutData(c,#13);

    {Liste der Mails anzeigen}
    List(c,'',FALSE);

    {Anzahl Logins in USER.BOX um 1 erhhen}
    AddOneLogin(CutSSID(KS[c]^.Call));

    {LastLogin mit der aktuellen Zeit+Datum setzen}
    SetLogin(c);

    PutData(c,#13+BoxPrompt(c));
    IF OwnBoxData^.SF_mit_jedem THEN
       PutData(c,#13+'');
  END;
END;


{Kommandos auswerten (testcommand) und in die jeweiligen funktionen springen}
PROCEDURE AuswertCommand(c: BYTE; S: STRING);
VAR cmd: WORD;
    Tmp2,TmpCmdQueue: pBoxCmdQueue;
    Hlp,StrTmp: STRING;
BEGIN
  IF (S[1]='[') AND (POS(']',S)>0) THEN BEGIN
    {CheckSID untersucht die empfangene SID nach untersttzten Modes,
     initialisiert die entsprechenden Variablen und setzt den BOX-Status}
    CheckSID(c,COPY(S,1,LENGTH(S)-1));
  END
  ELSE BEGIN

    IF KS[c]^.BoxData^.Start_SF THEN BEGIN
      KS[c]^.BoxData^.Start_SF := FALSE;

      {Anzahl Logins in USER.BOX um 1 erhhen}
      AddOneLogin(CutSSID(KS[c]^.Call));
      {LastLogin mit der aktuellen Zeit+Datum setzen}
      SetLogin(c);
      {Systemsprache}
      KS[c]^.BoxData^.Spk := GetSpk(c);
      PutData(c,#13+SysText(c,121)+{'Normal BBS-Mode activated....'}#13#13);
    END;

    IF LENGTH(S)>0 THEN BEGIN

      {Variable fr Idle-Time}
      KS[c]^.BoxData^.LastSendTime := CurrIxTime;

      StrTmp := S;
      IF KS[c]^.TxW=0 THEN BEGIN
        IF POS(';',StrTmp)>0 THEN BEGIN
          S := COPY(StrTmp,1,POS(';',StrTmp)-1)+#13;
          StrTmp := COPY(StrTmp,POS(';',StrTmp)+1,255);
        END
        ELSE BEGIN
          S := StrTmp;
          StrTmp := '';
        END;
      END;

      WHILE LENGTH(StrTmp)>0 DO BEGIN
        IF POS(';',StrTmp)>0 THEN BEGIN
          Hlp := COPY(StrTmp,1,POS(';',StrTmp)-1)+#13;
          StrTmp := COPY(StrTmp,POS(';',StrTmp)+1,255);
        END
        ELSE BEGIN
          Hlp := StrTmp;
          StrTmp := '';
        END;

        NEW(Tmp2);
        IF KS[c]^.BoxData^.CmdQueue=NIL THEN KS[c]^.BoxData^.CmdQueue := Tmp2
        ELSE BEGIN
          TmpCmdQueue := KS[c]^.BoxData^.CmdQueue;
          WHILE TmpCmdQueue^.Next <> NIL DO TmpCmdQueue := TmpCmdQueue^.Next;
          TmpCmdQueue^.Next := Tmp2;
        END;
        Tmp2^.Next := NIL;
        Tmp2^.Befehl := Hlp;
      END;

      IF KS[c]^.TxW>0 THEN Exit;
    END;

    REPEAT
      IF S='' THEN BEGIN
        TmpCmdQueue := KS[c]^.BoxData^.CmdQueue;
        S := TmpCmdQueue^.Befehl;
        KS[c]^.BoxData^.CmdQueue := TmpCmdQueue^.Next;
        DISPOSE(TmpCmdQueue);
      END;

      cmd := testcommand(c,S,boxcmds);

      CASE cmd OF
         1: Box_QUIT(c);
         2: Box_Info(c);
         4: List(c,S,FALSE);
         5: BEGIN
              READ_CMD(c,S);
              Exit;
            END;
         6: Send(c,S);
         7: CHECK_CMD(c,S,FALSE);
         8: DIR(c,S);
         9: LT_CMD(c,S);
        10: Erase_CMD(c,S);
        11: Usage(c,s);
        12: BID_CMD(c,S);
        13: Hilfe_CMD(c,S);
      (*  14: Pass(c,s);*)
        15: DefLT_CMD(c);
        16: Kopf_CMD(c,S);
        17: SET_CMD(c,s);
        18: KnownUser(c,s);
{        19: ListSF(c);}
        19: NewListSF(c);
        20: Activity(c);
        21: Aktuell(c);
        22: Forward_Cmd(c,S);
        23: BEGIN
              Box_NewMail;
              PutData(c,#13+SysText(c,120)+#13#13);
            END;
        24: Name(c,S);
        25: Box_BYE(c,FALSE);
        26: Spk_CMD(c,S);
        {27: RUN}
        28: BEGIN        
              PutData(c,'MCUT Version '+version);
              {$IFOPT G+}
               PutData(c,' 286');
              {$ENDIF}
              {$IFDEF OVR}
                {$IFOPT G+}
                  PutData(c,'/');
                {$ELSE}
                  PutData(c,' ');
                {$ENDIF}
                PutData(c,'OVR');
              {$ENDIF}
	      {$IFDEF LINUX}
	       PutData(c,' (LinuX) ');
	       {$ELSE}
	       PutData(c,' (DOS) ');
	       {$ENDIF}
              PutData(c,''+#13);
              PutData(c,'Copyright 1993-1997 DG4IAD and DG6VJ'+#13);
              PutData(c,'compiled '+compiled+#13);
              PutData(c,'Distributed under the GNU Public Licence'+#13);
              PutData(c,'PR-Interface:');
              IF device=0 THEN
              BEGIN
                {$IFDEF WA8DED}
                PutData(c,'WA8DED (');
                str(tncchan,ein_s);
                PutData(c,ein_s+' channels');
                IF xhost THEN
                  PutData(c,'/'+'XHOST');
                PutData(c,')'+#13);
                IF TNC_AN THEN
                  putdata(c,'('+sendcmd(0,'v')+')'+#13);
                {$ENDIF}
              END ELSE
              IF device=1 THEN
              BEGIN
                {$IFDEF FLEXNET}
                PutData(c,'PC/FlexNet '+l2_pversion);
                IF flextype=1 THEN PutData(c,' mini'+#13) ELSE
                  PutData(c,' digi'+#13);
                {$ENDIF}
              END ELSE
                PutData(c,'unknown'+#13);
              IF Pos('P',Gross(s))>0 THEN ShowVariables(c);
              IF Pos('X',Gross(s))>0 THEN BEGIN
                PutData(c,'this version includes following modules:'+#13);

                PutData(c,'Kernel                (DG4IAD)'+#13);
                {$IFDEF TERM}                        {DG4IAD}
                 PutData(c,'Terminal/Console     (DG4IAD)'+#13);
                {$ENDIF}
                {$IFDEF WA8DED}                   
                PutData(c,'TNC/TFPC* Interface   (DG4IAD/DG6VJ)'+#13);
                {$ENDIF}
                {$IFDEF BOX}                         
                PutData(c,'Mailbox               (DG6VJ)'+#13);
                {$ENDIF}
                {$IFDEF CONVERS}                     {DG6VJ}
                 PutData(c,'Convers               (DG6VJ)'+#13);
                {$ENDIF}
                {$IFDEF FLEXNET}
                 PutData(c,'PC/FlexNet Interface  (DG4IAD/DG9FDL)'+#13);
                {$ENDIF}
                {$IFDEF BCRX}
                 PutData(c,'PACSAT-Broadcast RX   (DG4IAD)'+#13);
                {$ENDIF}
                {$IFDEF HELP}
                 PutData(c,'Online Help          (DG4MMI)'+#13);
                {$ENDIF}
                str(memavail,s);
                PutData(c,'Coreleft: '+s);
		 str(maxavail,s);PutData(c,' ('+s+')');
                PutData(c,' , running since: '+DTDateStr(Unix2Pack(starttime))+' '+DTTimeStr(Unix2Pack(starttime))+#13);
                Str(Through_RX,s);
                PutData(c,'avar. throughput (last 10s) : '+s+' Byte/s (RX), ');
                Str(Through_TX,s);
                PutData(c,s+' Byte/s (TX)'+#13);
                str(SysLoad,s);
                PutData(c,'System Load: '+s+' Percent');
                str(last_rnds,s);
                PutData(c,', rps: '+s+#13);
             END;
            END;  
        29: MYBBS_CMD(c,S);
        30: SF_Poll(c,S,TRUE);
        31: BBS_CMD(c,S);
        32: MSG(c,S);
        33: GARBAGE(c,TRUE);
        34: Transfer(c,S);
        {$IFDEF CONVERS}
        35: StartConv(c,S);
        {$ENDIF}
        36: ListReject(c);
        37: NotHold_Cmd(c,S);
        38: BEGIN
              KS[c]^.Lev := KS[c]^.Lev - 10;
              PutData(c,#13+SysText(c,119){'OK, Du bist jetzt nichtmehr als SysOp eingeloggt.'}+#13#13);
            END;
        39: Undelete(c,S);
        40: Reload_CMD(c,s);
        41: Route_CMD(c,s);
        42: Reply_CMD(c);
        43: Comment_CMD(c);
        {$IFDEF EDITOR}
        44: XReply_CMD(c);
        {$ENDIF}
        45: CONFIG_CMD(c);
        46: NEXT_CMD(c,s);
        47:BEGIN
             S:=GROSS(LTRIM(S));
             DEC(byte(S[0]));
             S:=COPY(S+' ',POS(' ',S)+1,255);
             PutData(c,s+#13);
             S:=LTRIM(RTRIM(S));
             IF s='' THEN
             BEGIN
               IF KS[c]^.compress>0 THEN
                 KS[c]^.compress:=0
               ELSE
               BEGIN
                 PutData(c,'//COMP 1'+#13);
                 KS[c]^.Compress:=1;
               END;
             END ELSE 
             IF (gross(s)='ON') THEN
             BEGIN
               PutData(c,'//COMP 1'+#13);
               KS[c]^.Compress:=1;
             END
             ELSE
             IF S='1' THEN
               KS[c]^.compress:=2
             ELSE
             IF (gross(s)='OFF') THEN
             BEGIN
               PutData(c,'//COMP 0'+#13);
               KS[c]^.compress:=0;
             END
             ELSE
             IF S='0' THEN
                KS[c]^.compress:=0;
           END;
        ELSE PutData(c,'Invalid Command'+#13);
      END;

      S := '';
    UNTIL KS[c]^.BoxData^.CmdQueue=NIL;

    IF (KS[c]^.RxW<=0) AND (KS[c]^.Status=50) AND (KS[c]^.BoxData^.status=0)
       AND ((KS[c]^.FLAGS AND KS_DiscReq)=0) THEN PutData(c,BoxPrompt(c));

  END;
END;


{Verwaltung des Box-Status's}
PROCEDURE HandleBox(c:BYTE;s:STRING);
VAR St: STRING;
BEGIN
  if not box_is_running then
  begin
    PutData(c,'BOX is currently disabled'+#13);
    KS[c]^.FLAGS:=KS[c]^.flags OR KS_DISCREQ;
    exit;
  end;
  CASE KS[c]^.status OF
    50: BEGIN
          IF KS[c]^.BoxData^.Proto THEN ProtoEingabe(c,S);

          CASE KS[c]^.BoxData^.status OF
            0 : AuswertCommand(c,S);
            1 : Send_CallEingeb(c,S);
            2 : Send_Titeleingeb(c,S);
            3 : FileEingeben(c,S);
            4 : SetOptionsDialog(c,S);
          END;
        END;
    51	      : DieBox_SF(c,S);
    52	      : BEGIN
          IF KS[c]^.FBBSFData^.DelOK THEN BEGIN
            KS[c]^.FBBSFData^.DelOK := FALSE;
            delay(1000);
          END;
          FBB_SF(c,S);
        END;
    59	      : Passwort_Check(c,S);
    60,61	      : SFConnectDID(c,S);      {S&F-Connect wurde gemacht}
  
  END;
END;

PROCEDURE Box_Disc(C:BYTE);
VAR P,p2 : Pointer;
BEGIN
  CASE KS[c]^.status OF
    50,80,81: BEGIN
	   IF KS[c]^.BoxData=NIL THEN exit;
          CASE KS[c]^.BoxData^.status OF
            0: IF KS[c]^.BoxData^.Proto THEN BEGIN
                 CLOSE(KS[c]^.BoxData^.ProtoFile);
                 KS[c]^.BoxData^.Proto := FALSE;
               END;
            3: BEGIN
                 {$I-}
                 CLOSE(KS[c]^.BoxData^.SendData^.f);
                 {$I+}
                 IF IOResult=0 THEN BEGIN END;
               END;
          END;
          IF KS[c]^.BoxData^.Prompt=255 THEN
	     Dispose(KS[c]^.BoxData^.Prompt_str);
          IF (KS[c]^.status=81) THEN
	  BEGIN
	     IF KS[c]^.BoxData^.ListAusgabe<>NIL THEN dispose(KS[c]^.BoxData^.ListAusgabe);
	  END;
	  IF   (ks[c]^.status=80) THEN
	  BEGIN
	     IF KS[c]^.BoxData^.CheckAusgabe<>NIL THEN dispose(KS[c]^.BoxData^.CheckAusgabe);
	  END;
          IF KS[c]^.BoxData^.FirstBoxRead<>NIL THEN
          BEGIN
          END;
        END;
    51: BEGIN
          CASE KS[c]^.DBSFData^.status OF
            2: IF KS[c]^.DBSFData^.BIN THEN CLOSE(KS[c]^.DBSFData^.BIN_File)
                                       ELSE CLOSE(KS[c]^.DBSFData^.f);
	  END; { case }
	   WriteLn(maxavail);
          DISPOSE(KS[c]^.DBSFData);
	   WriteLn(maxavail);
	   Writeln;
        END;
    52: DISPOSE(KS[c]^.FBBSFData);
  END;
END;


{Kontrolliert in Boxpath+'INPORT', ob Files vorhanden sind.
 Wenn ja -> in die Box importieren}
PROCEDURE Box_NewMail;
BEGIN
  ImportFiles;
END;



PROCEDURE Auto_SF_Poll;
VAR
    S,Pfad: STRING;
    ClockSpalte,aword: WORD;
    FreeSpace:LONGINT;
    tmp: pBoxSF;DT:DateTime;
BEGIN
(*  {Erstmal gucken, ob genug speicher vorhanden ist.}
  FreeSpace := DiskFree(Ord(Upcase(BoxPath[1]))-64);
  FreeSpace := FreeSpace DIV 1024; *)
  {Wenn zu wenig frei ist, diese Routine verlassen.}
  IF (FreeSpace<OwnBoxData^.SF_Ab_kBytes) AND (OwnBoxData^.SF_Ab_kBytes<>0) THEN Exit;


  {Aktuelle Zeit, etwas kompliziert da ab Mai '96 jede Zeit ber
   CurrIxTime geholt wird...}

  UnPackTime(Unix2Pack(CurrIxTime),DT);
  ClockSpalte:=DT.Hour;
  tmp := BoxSFRoot;     {Start der S&F-Configuration im Speicher}
   WHILE tmp<>NIL DO BEGIN
     (* den Dummy-Partner wollen wir nicht connecten.... *)
     IF gross(tmp^.call)<>'LOKAL' THEN
       CASE tmp^.Times[ClockSpalte] OF
        (* Bei A/U erstmal gucken ob ueberhaupt was anliegt... *)
        'A':IF SendFileDa(tmp^.call,'A',$FFFF) THEN
               MakeConnect(OwnBoxData^.SF_Call,tmp^.Pfad,60);
        'U':IF SendFileDa(tmp^.call,'U',$FFFF) THEN 
              MakeConnect(OwnBoxData^.SF_Call,tmp^.Pfad,60);
        'P':MakeConnect(OwnBoxData^.SF_Call,tmp^.pfad,60);     
    END;
    tmp := tmp^.next;
  END;
END;




PROCEDURE GetMailStart(C:BYTE;filename:string;header:BOOLEAN);
BEGIN
END;

FUNCTION  GetMailData(C:BYTE;var DATA:STRING):BOOLEAN;
BEGIN
END;


(***************************************************************************)
(*                   Neue Box_Send_Queue (iad, dez 95)                     *)
(*    Erledigt neben BoxReadQueue auch die abarbeitung von List und        *)
(*    Check im Hintergrund.                                                *)
(***************************************************************************)


{ Kontrolliert jeden Kanal, auf dem jemand in der Box eingeloggt ist,
 nach ausstehenden Bytes. Wenn kein Byte mehr zum Senden vorliegt, wird
 in der Send-Queue geguckt, ob noch was zum Senden vorliegt. Wenn ja werden
 5k hchstens gesendet (kann in BOXVARS eingestellt werden - Konstante
 MaxBoxFrameSize) klappt leider noch nicht.

 NEU (dg6vj, mar 96):
 Check-Listen-Ausgabe im Hintergrund. (03.03.96)
 List-Befehls-Ausgabe im Hintergrund (dg6vj, 18.03.96)
}
PROCEDURE Box_Send_Queue;
TYPE tArr250 = ARRAY[1..250] OF CHAR;
VAR b: WORD;
    Ready: BOOLEAN;
    bytes: WORD;
    tmp: pBoxRead;
    Last,S,Hlp: STRING;
    anzhead: BYTE;
    Result: WORD;
    Arr250: tArr250;
    RestLT: INTEGER;
BEGIN
  FOR b := 0 TO 255 DO BEGIN
    IF KS[b]<>NIL THEN BEGIN

      {Check-Befehlsausgabe}
      IF KS[b]^.status=80 THEN BEGIN
        {Wenn nichts mehr zum Senden vorliegt wird weiter geguckt, was noch
         da ist.}
        IF KS[b]^.TxW=0 THEN CHECK_CMD(b,'',TRUE);
        Exit;
      END;

      {List-Befehlsausgabe}
      IF KS[b]^.status=81 THEN BEGIN
        {Wenn nichts mehr zum Senden vorliegt wird weiter geguckt, was noch
         da ist.}
        IF KS[b]^.TxW=0 THEN List(b,'',TRUE);
        IF (KS[b]^.BoxData^.CmdQueue=NIL)
               AND (KS[b]^.BoxData^.ListAusgabe=NIL)
               AND (KS[b]^.RxW=0)
               AND (KS[b]^.BoxData^.status=0) THEN PutData(b,BoxPrompt(b));
        Exit;
      END;

      {In der Mailbox eingeloggt?}
       IF (KS[b]^.status=50) AND (KS[b]^.BoxData<>NIL) THEN BEGIN
        IF (KS[b]^.BoxData^.status = 0) THEN BEGIN
          IF (KS[b]^.TxW=0) THEN BEGIN
            WITH KS[b]^.BoxData^ DO BEGIN
              Ready := FALSE;
              bytes := 0;
              REPEAT
                IF FirstBoxRead <> NIL THEN BEGIN
                  IF SendData=NIL THEN BEGIN
                    new(SendData);
                    SendData^.BIN := FALSE;
                  END;
                  IF FirstBoxRead^.Started THEN BEGIN

                  END
                  ELSE BEGIN
                    ASSIGN(SendData^.f,BoxPath+FirstBoxRead^.IdxInfo.FileName);
                    {$I-}
                    RESET(SendData^.f);
                    {$I+}
                    IF IOResult=0 THEN BEGIN

                      {File-Start-Markierung ausgeben}
                      PutData(b,#13+'{TOF}'+#13);

                      {Header bauen}
                      S := FirstBoxRead^.IdxInfo.Absender+' > '+FirstBoxRead^.IdxInfo.Rubrik+'   ';
                      IF FirstBoxRead^.Set_Info AND SET_Datum>0 THEN
                          S := S + Pack2STRDate(FirstBoxRead^.IdxInfo.RX_Datum)+' ';
                      IF FirstBoxRead^.Set_Info AND SET_Uhrzeit>0 THEN
                          S := S + Pack2STRTime(FirstBoxRead^.IdxInfo.RX_Datum)+' ';
                      IF FirstBoxRead^.Set_Info AND SET_Bytes>0 THEN BEGIN
                        STR(FirstBoxRead^.IdxInfo.Groesse,Hlp);
                        S := S + Hlp+' Bytes'
                      END;
                      IF FirstBoxRead^.Set_Info AND SET_LifeTime>0 THEN BEGIN
                        S := S + '  #';
                        {Verbleibene Lifetime ausrechnen}
                        RestLT := PackTime2Int(CurrIxTime)-PackTime2Int(FirstBoxRead^.IdxInfo.RX_Datum);
                        RestLT := FirstBoxRead^.IdxInfo.LifeTime - RestLT;
                        STR(RestLT,Hlp);
                        S := S + Hlp;
                      END;
                      S := S + '  @'+FirstBoxRead^.IdxInfo.MBX;
                      {Mail hold?}
                      IF FirstBoxRead^.IdxInfo.Flags AND VERWALT_HOLD>0 THEN S := S + '      MSG HOLD!!!';

                      FirstBoxRead^.LEN := LENGTH(S);  {Gre der gesendeten Daten}
                      PutData(b,S+#13);
                      bytes := bytes + LENGTH(S)+1;
                      S := 'BID : '+FirstBoxRead^.IdxInfo.BID;
                      FirstBoxRead^.LEN := FirstBoxRead^.LEN + LENGTH(S);
                      PutData(b,S + #13);              {BID-Zeile senden}
                      bytes := bytes + LENGTH(S)+1;

                      IF FirstBoxRead^.Set_Info AND SET_Read>0 THEN BEGIN
                        SendReadLine(b, FirstBoxRead^.LEN, BoxPath+FirstBoxRead^.IdxInfo.FileName);
                      END;

                      S := 'Subj: '+FirstBoxRead^.IdxInfo.Titel;
                      FirstBoxRead^.LEN := FirstBoxRead^.LEN + LENGTH(S);
                      PutData(b,S + #13);              {Subject-Zeile}
                      bytes := bytes + LENGTH(S)+1;


                      {Header abschneiden}
                      S := '';
                      FirstBoxRead^.BINOffset := 0;
                      WHILE NOT EOF(SendData^.f) AND (S <> 'NNNN') DO BEGIN
                        READLN(SendData^.f,S);
                        FirstBoxRead^.BINOffset := FirstBoxRead^.BINOffset + LENGTH(S) + 2;
                      END;

                      anzhead := 0;
                      Hlp := 'Path: !';
                      Last := '';
                      SendData^.BIN := FALSE;
                      FirstBoxRead^.Kompr := FirstBoxRead^.Set_Info AND SET_R_Kurz>0;
                      WHILE NOT EOF(SendData^.f) AND NOT SendData^.BIN DO BEGIN
                        READLN(SendData^.f,S);
                        IF COPY(S,1,5)='#BIN#' THEN BEGIN
                          SendData^.BIN := TRUE;
                          PutData(B,S);
                          FirstBoxRead^.BINOffset := FirstBoxRead^.BINOffset + LENGTH(S) + 2;
                        END
                        ELSE BEGIN
                          FirstBoxRead^.BINOffset := FirstBoxRead^.BINOffset + LENGTH(S) + 2;
                          IF (S[1]='R') AND (S[2]=':') AND FirstBoxRead^.Kompr THEN BEGIN
                            Last := COPY(S,3,255);
                            anzhead := anzhead + 1;
                            S := COPY(S,17,255);
                            IF POS(' ',S) > 0 THEN S := COPY(S,1,POS(' ',S)-1);
                            IF POS(':',S) > 0 THEN S := COPY(S,POS(':',S)+1,255);
                            IF POS('.',S) > 0 THEN S := COPY(S,1,POS('.',S)-1);
                            IF POS('@',S) > 0 THEN S := COPY(S,POS('@',S)+1,255);
                            Hlp := Hlp + S+'!';

                            IF anzhead = 10 THEN BEGIN
                              anzhead := 0;
                              FirstBoxRead^.LEN := FirstBoxRead^.LEN + LENGTH(Hlp);
                              PutData(b,Hlp+#13);
                              bytes := bytes + LENGTH(Hlp)+1;
                              Hlp := '      !';
                            END;
                          END
                          ELSE BEGIN
                            IF FirstBoxRead^.Kompr THEN BEGIN
                              FirstBoxRead^.Kompr := FALSE;
                              IF anzhead > 0 THEN BEGIN
                                FirstBoxRead^.LEN := FirstBoxRead^.LEN + LENGTH(Hlp);
                                PutData(b,Hlp+#13);
                                bytes := bytes + LENGTH(Hlp)+1;
                              END;
                              IF FirstBoxRead^.Set_Info AND SET_Sender>0 THEN BEGIN
                                Hlp := 'Sent: '+Last;
                                FirstBoxRead^.LEN := FirstBoxRead^.LEN + LENGTH(Hlp);
                                PutData(b,Hlp+#13);
                                bytes := bytes + LENGTH(Hlp)+1;
                              END;
                            END;
                            FirstBoxRead^.LEN := FirstBoxRead^.LEN + LENGTH(S);
                            PutData(b,S+#13);
                            bytes := bytes + LENGTH(S)+1;
                          END;
                        END;
                      END;
                      IF SendData^.BIN THEN BEGIN
                        CLOSE(SendData^.f);
                        ASSIGN(SendData^.BIN_f,BoxPath+FirstBoxRead^.IdxInfo.FileName);
                        RESET(SendData^.BIN_f,1);
                        SEEK(SendData^.BIN_f,FirstBoxRead^.BINOffset-1);
                        REPEAT
                          BLOCKREAD(SendData^.BIN_f,s[1],250,Result);
                          S[0] := Chr(Lo(Result));
                          PutData(b,S);
                          bytes := bytes + Result;
                          FirstBoxRead^.LEN := FirstBoxRead^.LEN + LENGTH(S);
                        UNTIL Result < 250;
                        CLOSE(SendData^.BIN_f);
                      END
                      ELSE CLOSE(SendData^.f);


                      PutData(b,#13);
                      STR(FirstBoxRead^.LEN,Hlp);
                      PutCallToReadLine(b,BoxPath+FirstBoxRead^.IdxInfo.FileName, CutSSID(KS[b]^.Call));
                      AddOneRead(CutSSID(KS[b]^.Call));
                      PutData(b,'{EOF|'+Hlp+'}'+#13#13);

                      {Informationen ber das zuletzt gelesene File im
                       KS-Record speichern. (fr REPLY und COMMENT)}
                      KS[b]^.BoxData^.M_Sender := FirstBoxRead^.IdxInfo.Absender;
                      KS[b]^.BoxData^.M_Titel := FirstBoxRead^.IdxInfo.Titel;
                      KS[b]^.BoxData^.M_Verteil := FirstBoxRead^.IdxInfo.MBX;
                      {$IFDEF EDITOR}
                      KS[b]^.BoxData^.M_Filename := FirstBoxRead^.IdxInfo.FileName;
                      {$ENDIF}

                      tmp := FirstBoxRead;
                      FirstBoxRead := FirstBoxRead^.Next;
                      DISPOSE(tmp);

                    END
                    ELSE BEGIN
                      tmp := FirstBoxRead;
                      FirstBoxRead := FirstBoxRead^.Next;
                      DISPOSE(tmp);
                      PutData(b,#13+SysText(b,44)+#13#13);
                    END;
                  END;
                  IF (KS[b]^.BoxData^.CmdQueue=NIL) AND (KS[b]^.BoxData^.FirstBoxRead=NIL) AND (KS[b]^.RxW=0)
                                                    AND (KS[b]^.BoxData^.status=0) THEN
                          PutData(b,BoxPrompt(b));
                END
                ELSE BEGIN
                  IF SendData<>NIL THEN BEGIN
                    DISPOSE(SendData);
                    SendData := NIL;
                  END;
                  IF CmdQueue<>NIL THEN AuswertCommand(b,'');
                  Ready := TRUE;
                END;
              UNTIL Ready OR (bytes>=MaxBoxFrameSize);
            END;
          END;
        END;
      END;
    END;
  END;
END;



END.
