(***************************************************************************)
(**                             UNIT CONVHNEU                             **)
(***************************************************************************)
(**  Implementation eines schleifenfreien Converses nach DG6VJ :-)        **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
UNIT CONVHNEU;


INTERFACE

TYPE str15 = STRING[15];

(************************* CONVERS-BEFEHLE *********************************)
PROCEDURE CMD_CMSG(Host: str15; Time: LONGINT; User: str15; Chan: INTEGER; Text: STRING; NotTo: BYTE);

PROCEDURE AuswertConversCommand(ch: BYTE; S: STRING);
PROCEDURE HostLogin(ch: BYTE; S: STRING);


IMPLEMENTATION

USES BOXUTIL,CONVVAR,IADVAR,DOS,VIDEO,TOOLBOX,CONVERS;


(*
 *  FUNCTION AktUnixTime
 * Aktuelle Zeit in UnixTime
 *)
FUNCTION AktUnixTime: LONGINT;
BEGIN
    AktUnixTime := CurrIxTime;
END;



(***************************************************************************)
(**                          CONVERS-BEFEHLE                              **)
(***************************************************************************)


(*
 *  PROCEDURE CMD_CMSG
 * Eine Msg an alle Stationen auf dem aktuellen Kanal wird verschickt.
 *)
PROCEDURE CMD_CMSG(Host: str15; Time: LONGINT; User: str15; Chan: INTEGER; Text: STRING; NotTo: BYTE);
VAR S,Hlp: STRING;
    b: BYTE;
BEGIN
  S := '/'#255#128'CMSG '+Host+' ';
  STR(Time,Hlp);
  S := S + Hlp + ' ' + User + ' ';
  STR(CHan,Hlp);
  S := S + Hlp + ' ' + Text;

  FOR b := 0 TO 255 DO IF KS[b]<>NIL THEN IF KS[b]^.status=111 THEN IF b<> NotTo THEN
       PutData(b,S+#13);
END;


(*
 *  PROCEDURE CMD_OPER
 * Eine Station als Channel-Operator setzen.
 *)
PROCEDURE CMD_OPER(ch: BYTE; von,an: str10; Kanal: INTEGER);
BEGIN
END;


(*
 *  PROCEDURE CMD_ULOGIN
 * Ein User loggt in einem Kanal ein.
 *)
PROCEDURE CMD_ULOGIN(ch: BYTE; Call: str10; Hostname: str15;Time: LONGINT; Chan: INTEGER; Pers: str127);
VAR S,Hlp: STRING;
    b: BYTE;
BEGIN
  S := '/'#255#128'ULOGIN '+Call+' '+Hostname+' ';
  STR(Time,Hlp);
  S := S + Hlp + ' ';
  STR(Chan,Hlp);
  S := S + Hlp;
  IF Byte(Pers[0])>0 THEN S := S + ' ' + Pers;
  PutData(ch,S+#13);
END;

(**************************************************************************)
(**************************************************************************)
(**************************************************************************)

(**************************************************************************)
(**         Hier stehen die Prozeduren fr die Befehle, die              **)
(**       von anderen Hosts kommend ausgewertet werden mssen            **)
(**************************************************************************)

(*
 *  PROCEDURE RX_ULOGIN
 * Ein User loggt neu in einen Kanal ein
 *)
PROCEDURE RX_ULOGIN(ch: BYTE; S: STRING);
VAR tmp: pExtUser;
    Call,Hostname,UserID: str15;
    Hlp: STRING;
    Time: LONGINT;
    code: WORD;
    ToChan: INTEGER;
    b: BYTE;
    ChanFlags: BYTE;
    tmp2: pConvUserChan;
    OK: BOOLEAN;
BEGIN
  Call := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);
  Hostname := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);
  Hlp := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);
  VAL(Hlp,Time,code);
  IF code<>0 THEN Exit;
  IF POS(' ',S)>0 THEN BEGIN
    Hlp := COPY(S,1,POS(' ',S)-1);
    S := COPY(S,POS(' ',S)+1,255);
  END
  ELSE BEGIN
    Hlp := S;
    S := '';
  END;
  VAL(Hlp,ToChan,code);
  IF code<>0 THEN Exit;

  IF ToChan>=0 THEN BEGIN
    tmp:=ExtUserRoot;
    IF tmp=NIL THEN BEGIN
      new(ExtUserRoot);
      tmp:=ExtUserRoot;
    END
    ELSE BEGIN
      tmp:=ExtUserRoot;
      WHILE tmp^.next<>NIL DO tmp:=tmp^.next;
      New(tmp^.Next);
      tmp:=tmp^.Next;
    END;

    tmp^.Next := NIL;
    tmp^.Call := Call;
    tmp^.Host := Hostname;
    tmp^.Via_Host := KS[ch]^.ConvHost^.Hostname;
    tmp^.Channel := ToChan;
    tmp^.Pers := S;
    tmp^.Away := FALSE;
    tmp^.AwaySince := 0;
    tmp^.AwayText := '';
    tmp^.Operator := FALSE;
    tmp^.From_Oper := '';
    tmp^.ChanOp := FALSE;
    tmp^.From_Chanop := '';
    tmp^.Login := AktUnixTime;
    tmp^.LastText := tmp^.Login;

    {Im Kanal-Record einen User dabei}
    AddOneUserAtChannel(tmp^.Channel);

    ChanFlags := GetChannelFlags(tmp^.Channel);
    Hlp := '*** ('+ConvTime+') '+Call+'@'+Hostname+' joined ';
    IF ChanFlags AND SECRET>0 THEN Hlp := Hlp + 'this secret channel'
    ELSE IF ChanFlags AND INVISIBLE>0 THEN Hlp := Hlp + 'this invisible channel'
    ELSE BEGIN
      STR(tmp^.Channel,S);
      Hlp := Hlp + 'channel '+S;
    END;
    IF LENGTH(S)>0 THEN Hlp := Hlp + #13 + '    ('+S+')';

    FOR b := 0 TO 255 DO IF KS[b]<>NIL THEN IF KS[b]^.status=6 THEN BEGIN
      tmp2 := KS[b]^.ConvData^.Channels;
      OK := FALSE;
      WHILE (tmp2<>NIL) AND NOT OK DO BEGIN
        IF (tmp2^.Channel=tmp^.Channel) OR KS[b]^.ConvData^.Verb THEN BEGIN
          SendString(b,Hlp+#13);
          OK := TRUE;
        END;
        tmp := tmp^.next;
      END;
    END;

    FOR b := 0 TO 255 DO IF KS[b]<>NIL THEN IF KS[b]^.status=111 THEN IF b<> ch THEN
        CMD_ULOGIN(b,Call,Hostname,Time,ToChan,S);

  END

END;


(*  PROCEDURE RX_CMSG
 * Messages in einem Kanal fr alle eingeloggten User
 *)
PROCEDURE RX_CMSG(ch: BYTE; S: STRING);
VAR tmp: pDesti;
    Hostname: str15;
    OK: BOOLEAN;
    Hlp: STRING;
    code: WORD;
    Time: LONGINT;
    Call: str15;
    Chan: INTEGER;
    b: BYTE;
    text,text2: STRING;
    tmp2: pConvUserChan;
BEGIN
  {Variablen-Initialisierung}
  OK := FALSE;
  IF S='' THEN Exit;

  Hostname := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);

  {Gucken, ob dieser Host berhaupt bekannt ist}
  tmp := DestiRoot;
  WHILE tmp<>NIL DO BEGIN
    IF tmp^.Host=Hostname THEN BEGIN
      Hlp := COPY(S,1,POS(' ',S)-1);
      S := COPY(S,POS(' ',S)+1,255);
      VAL(Hlp,Time,code);
      IF code<>0 THEN Exit;
      IF tmp^.TimeFrom<Time THEN BEGIN
        tmp^.TimeFrom := Time;
        OK := TRUE;
      END
      ELSE Exit;
    END;
    tmp := tmp^.next;
  END;

  IF OK THEN BEGIN
    {OK, dieses Paket kann angenommen werden. In S steht jetzt noch das
     Call, der Kanal und der eigentliche Text}
    Call := COPY(S,1,POS(' ',S)-1);
    S := COPY(S,POS(' ',S)+1,255);
    Hlp := COPY(S,1,POS(' ',S)-1);
    S := COPY(S,POS(' ',S)+1,255);
    VAL(Hlp,Chan,code);
    IF code<>0 THEN Exit;

    {Erstmal bekommen die anderen Hosts was}
    CMD_CMSG(Hostname,Time,Call,Chan,S,ch);

    {Und jetzt wird der Text an alle lokalen Stationen ausgegeben, die auch
     auf diesem Kanal sind.}
    FOR b := 0 TO 255 DO IF KS[b]<> NIL THEN BEGIN
      IF KS[b]^.status=6 THEN BEGIN
        tmp2 := KS[b]^.ConvData^.Channels;

        WHILE tmp2<>NIL DO BEGIN
          text2:=S;
          IF tmp2^.Channel=Chan THEN BEGIN
            IF Chan<>KS[b]^.ConvData^.AktChan THEN BEGIN
              STR(Chan,S);
              S := '<'+S+':'+Call+'>: ';
            END
            ELSE S := '<'+Call+'>: ';
            IF Call<>'conversd' THEN text2 := S + text2;
            REPEAT
              Hlp := COPY(text2,1,KS[b]^.ConvData^.Spalten);
              IF (POS(' ',Hlp)>0) AND (LENGTH(text2)>KS[b]^.ConvData^.Spalten) THEN
                Hlp := COPY(Hlp,1,Last(' ',Hlp)-1);
              PutData(b,Hlp+#13);
              text2 := StringD(' ',LENGTH(S)-1)+COPY(text2,LENGTH(Hlp)+1,255);
            UNTIL LTRIM(text2)='';
          END;
          tmp2 := tmp2^.Next;
        END;
      END;
    END;
  END;
END;

(**************************************************************************)
(**************************************************************************)
(**************************************************************************)


(*
 *  PROCEDURE AuswertConversCommand
 * Auswertung der Convers-Kommandos von anderen Hosts
 *)
PROCEDURE AuswertConversCommand(ch: BYTE; S: STRING);
CONST MaxCmdNr = 2;
      Command: ARRAY[1..MaxCmdNr] OF str10 = ('CMSG',
                                              'ULOGIN');
VAR CmdNr: BYTE;
    Found: BOOLEAN;
    Hlp: STRING;
BEGIN
  S := COPY(S,4,255);
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);

  IF POS(' ',S)>0 THEN BEGIN
    Hlp := COPY(S,1,POS(' ',S)-1);
    S := COPY(S,POS(' ',S)+1,255);
  END
  ELSE BEGIN
    Hlp := S;
    S := '';
  END;

  CmdNr := 0;
  Found := FALSE;
  REPEAT
    inc(CmdNr);
    IF Command[CmdNr]=Hlp THEN Found := TRUE;
  UNTIL (Command[CmdNr]=Hlp) OR (CmdNr>MaxCmdNr);

  IF Found THEN BEGIN
    CASE CmdNr OF
      1: RX_CMSG(ch,S);
      2: RX_ULOGIN(ch,S);
    END;
  END;
END;


(*
 *  PROCEDURE NewDestination
 * Trgt diesen Host in die Destinationliste ein. Hostname kommt ber Via
 * mit der angegebenen Revision.
 *)
PROCEDURE NewDestination(Hostname,Via:str15; Revision: str8; Zeit: WORD);
VAR tmp: pDesti;
    Found: BOOLEAN;
BEGIN
  tmp := DestiRoot;
  Found := FALSE;
  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Host=Hostname THEN BEGIN
      IF Zeit=0 THEN Exit;
      IF tmp^.Zeit>Zeit THEN BEGIN
        tmp^.Via := Via;
        tmp^.Zeit := Zeit;
        tmp^.Revis := Revision;
      END;
      Found := TRUE;
    END;
    tmp := tmp^.next;
  END;

  IF NOT Found THEN BEGIN
    {Destination neu eintragen}
    tmp:=DestiRoot;
    IF tmp=NIL THEN BEGIN
      new(DestiRoot);
      tmp:=DestiRoot;
    END
    ELSE BEGIN
      tmp:=DestiRoot;
      WHILE tmp^.next<>NIL DO tmp:=tmp^.next;
      New(tmp^.Next);
      tmp:=tmp^.Next;
    END;

    tmp^.next := NIL;
    tmp^.Host := Hostname;
    tmp^.Via := Via;
    tmp^.Revis := Revision;
    tmp^.Zeit := 0;
    tmp^.TimeFrom := 0;
  END;
END;



(*
 *  PROCEDURE SendConversStatus
 * Den kompletten Status des Converses an neu eingeloggte Hosts verschicken.
 * (Eingeloggte Stationen, Channel-Modes etc)
 *)
PROCEDURE SendConversStatus(ch: BYTE);
VAR b: BYTE;
    User_tmp: pConvUserChan;
    Ext_tmp: pExtUser;
BEGIN

  {In diesem Rechner eingeloggte Stationen}
  FOR b := 0 TO 255 DO IF KS[b]<>NIL THEN IF KS[b]^.status=6 THEN BEGIN
    IF KS[b]^.ConvData^.Operator THEN CMD_OPER(ch,'conversd',KS[b]^.ConvData^.Call,-1);
    User_Tmp := KS[b]^.ConvData^.Channels;
    WHILE User_tmp<>NIL DO BEGIN
      WITH KS[b]^.ConvData^ DO
         CMD_ULOGIN(ch,Call,OwnConvData^.Hostname,User_Tmp^.Login,User_tmp^.Channel,Pers);
      IF User_tmp^.Flags AND IS_CHANOP>0 THEN CMD_OPER(ch,User_tmp^.From_Oper,KS[b]^.ConvData^.Call,User_tmp^.Channel);
      User_tmp := User_tmp^.next;
    END;
  END;

  {Von auen eingeloggte Stationen}
  Ext_Tmp := ExtUserRoot;
  WHILE Ext_tmp<>NIL DO BEGIN
    CMD_ULOGIN(ch,Ext_tmp^.Call,Ext_tmp^.Host,Ext_tmp^.Login,Ext_tmp^.Channel,Ext_tmp^.Pers);
    Ext_Tmp := Ext_tmp^.next;
  END;
END;


(*
 *  PROCEDURE HostLogin
 * Login eines Hosts. (Jedenfalls ist die Syntax so)
 *)
PROCEDURE HostLogin(ch: BYTE; S: STRING);
VAR HName: STRING[10];
    Rev: STRING[8];
    Flags: STRING[10];

    EntryFound: BOOLEAN;
    tmp: pHostListe;
BEGIN
  HName := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);
  IF POS(' ',S)>0 THEN BEGIN
    Rev := COPY(S,1,POS(' ',S)-1);
    Flags := COPY(S,POS(' ',S)+1,255);
  END
  ELSE BEGIN
    Rev := S;
    Flags := '';
  END;

  {Kontrolle, ob die Station schon eingeloggt ist}
  EntryFound := FALSE;
  tmp := HostDataRoot;
  WHILE (tmp<>NIL) AND (NOT EntryFound) DO BEGIN
    IF tmp^.Hostname=HName THEN BEGIN
      EntryFound := TRUE;
      {Datensatz in der Host-Liste vervollstndigen}
      tmp^.Chan := ch;
      tmp^.State := 2;
      tmp^.Since := AktUnixTime;
      tmp^.Revision := Rev;
      KS[ch]^.ConvHost := tmp;
    END;
    tmp := tmp^.next;
  END;

  IF NOT EntryFound THEN BEGIN
    PutData(ch,#13'*** Host-Login not allowed'#13#13);
    KS[ch]^.Flags := KS[ch]^.Flags OR KS_DISCREQ;
    Exit;
  END;

  KS[ch]^.status := 111;        {MCuT-Hostverbindung}

  {Zur Destination-Liste dazu}
  NewDestination(KS[ch]^.ConvHost^.Hostname,KS[ch]^.ConvHost^.Hostname,Rev,0);

  {Antwort auf das /LOGIN generieren}
  PutData(ch,'/'#255#128'LOGOK '+OwnConvData^.Hostname+' mct-'+ConvRelease+#13);

  {Infos ber alle eingeloggten User senden}
  SendConversStatus(ch);
END;

END.
