{globale Variablen fr den Convers}
UNIT CONVVAR;


INTERFACE

TYPE
  str6=STRING[6];
  str8=STRING[8];
  str10=STRING[10];
  str15=STRING[15];
  str20=STRING[20];
  str127=STRING[127];

CONST ConvRelease = '1.0';
      {$IFDEF CONVNETZ}
      WhatIsThis = 'Ping-Pong-Convers';
      {$ELSE}
        {$IFDEF CONVNEU}
          WhatIsThis = 'Ding-Dong-Convers';
        {$ELSE}
          WhatIsThis = 'Local-Convers';
        {$ENDIF}
      {$ENDIF}
      UserFileVers = 'MCT000';

      {Konstanten fr die Channel-Modes}
      TOPIC_CHOP = 2;
      INVISIBLE = 4;
      SECRET = 8;
      MODERATE = 16;
      PRIVAT = 32;
      LOCAL = 64;

      {Konstanten fr User-Modes}
      IS_CHANOP = 1;

      {KS[]^.status fr Convers-Links und Sys-Passwort-eingabe}
      Status_ConvLink = 55;           {erstmal einen freien Box-status}
      Status_PrivEing = 56;

TYPE
   pConvUserChan = ^tConvUserChan;
   tConvUserChan = RECORD
     Next: pConvUserChan;
     Channel: INTEGER;
     Flags: WORD;               {Byte 0: User ist Ch-Op auf diesem
                                         Kanal.}
     Login: LONGINT;
     From_Oper: str15;          {Wer hat die Station zum Operator gemacht?}
   END;


tConvUser = RECORD
	       Call	    : str8;
	       Host	    : str15;
	       Via_Host	    : str15;
	       Pers	    : STRING[127];
	       Away	    : BOOLEAN;
	       AwayText	    : STRING[127];
	       AwaySince    : LONGINT;
	       AktChan	    : INTEGER;
	       LastStatus   : BYTE;
	       Verb	    : BOOLEAN;                     {Verbose-mode?}
	       OperatorFlag : BOOLEAN;
	       LastInviChan : INTEGER;             {Kanal, auf dem zuletzt eingeladen wurde}
	       RX_Bytes: LONGINT;
	       TX_Bytes: LONGINT;
	       LastText: LONGINT;
	       Spalten: BYTE;
	       Channels: pConvUserChan;
	    END;


   pChanRec = ^tChanRec;
   tChanRec = RECORD
     Next: pChanRec;
     Channel: INTEGER;
     Flags: WORD;               {Bit 0: Thema lt sich nur von Ch-Ops
                                        ndern (T)
                                     1: Kanal wird verheimlicht (invisible)
                                     2: Kanal ist geheim (Ch-Nr nicht mit
                                        anzeigen (S))
                                     3: Kanal ist moderiert. Nur ch-Ops
                                        drfen schreiben (M)
                                     4: Kanal ist Privat (einladung zum
                                        einloggen wird bentigt)
                                     5: Kanal ist Lokal. Texte werden nicht
                                        weiter verteilt (L)
                                }
     Users: WORD;               {Anzahl User}
     Topic: STRING;
     Topic_Who: str6;           {Wer setzte das Topic?}
     Topic_Who_Host: str15;     {auf welchem Host?}
     Topic_When: LONGINT;       {Wann?}
   END;

   pConvOwnData = ^tConvOwnData;
   tConvOwnData = RECORD
     Hostname: STRING[15];
     StartupTime: LONGINT;
   END;


   {So werden die User-Infos gespeichert.}
   tConvUserDataFile = RECORD
     Call: STRING[6];
     Pers: STRING[127];
     Bell: BOOLEAN;
     Spalten: BYTE;
   END;



{$IFDEF CONVNETZ}

{***************************************************************************}
{****           Datenstrukturen fr den vernetzten Convers              ****}
{***************************************************************************}

CONST
   OwnFlags = 'Admpu'; {Eigenes Features-Set}

TYPE
   pExtUser = ^tExtUser;
   tExtUser = RECORD    {User, die auf anderen Hosts eingeloggt sind}
     next: pExtUser;
     Call: STRING[6];
     Host: STRING[15];
     Via_Host: STRING[15];
     Channel: INTEGER;
     Pers: STRING[127];
     Away: BOOLEAN;
     AwaySince: LONGINT;
     AwayText: STRING[127];
     Operator: BOOLEAN;
     From_Oper: STRING[10];
     ChanOp: BOOLEAN;
     From_Chanop: STRING[10];
     Login: LONGINT;
     LastText: LONGINT;
   END;

   {Fr die Destination-Liste}
   pDesti = ^tDesti;
   tDesti = RECORD
     next: pDesti;
     Host: STRING[15];  {Hostname}
     Via: STRING[15];   {ber welche Station wird dieser Host erreicht?
                         (fr /msg z.B.}
     Revis: STRING[6];
     Zeit: WORD;        {Linkzeit in Sekunden}
     TimeFrom: LONGINT; {Es werden nur Pakete angenommen, deren Time-ID
                         grer ist, als diese.}
   END;

CONST
   {Flags fr die facilities (was auch immer das Wort zu bedeuten hat)
    der Link-Partner}
   FLG_OLD_AWAY = 1;
   FLG_DESTI_FORW = 2;
   FLG_CHAN_MODE = 4;
   FLG_PINGPONG = 8;
   FLG_UDAT = 16;
   FLG_NEW_AWAY = 32;

TYPE
   {Liste der Connects mit Hosts direkt mit uns. Zum Verschicken von
    Texten und zum Anzeigen in der /list - liste.}
   pHostListe = ^tHostListe;
   tHostListe = RECORD
     Next: pHostListe;
     Hostname: STRING[15];
     State: BYTE;               {0 = Disconnected
                                 1 = Connecting
                                 2 = Connected}
     RX_Qual: WORD;             {Empfangs-Qualitt (von PING/PONG-Befehlen)}
     TX_Qual: WORD;             {Sende-Qualitt - beides in sekunden}
     LastPing: LONGINT;         {Zeit des letzten Ping-Befehls}
     Revision: STRING[8];
     Flags: WORD;               {Siehe Konstanten-Definition ber dieser
                                 Deklaration}
     Since: LONGINT;            {Seit wann sind wir mit dieser Station
                                 connected/disconnected?}
     Tries: WORD;               {Wie oft wurde schon probiert zu connecten?
                                 Wird auch zur Berechnung von NextTry benutzt.
                                 (Die Zeit, die zwischen 2 connect-versuchen
                                 vergeht, wchst mit den miglckten Versuchen}
     Trusted: BOOLEAN;          {Soll nie probiert werden zu connecten,
                                 diese Station aber als Host akzeptieren?}
     RX_Bytes: LONGINT;         {Wieviele Bytes wurden an die Station gesendet}
     TX_Bytes: LONGINT;         {Wieviele Bytes wurden empfangen?}
     Pfad: STRING;              {Auf welchem Weg soll beim nchsten Versuch
                                 connected werden?}
     Chan: BYTE;                {Wenn der Connect steht, ist die Station
                                 auf diesem Kanal eingeloggt}
   END;


   {Die eingetragenen Links werden im File CONV.LNK abgespeichert.
    Folgendes Format:}
   tConvLinkFile = RECORD
     HostName: STRING[15];
     Pfad: STRING;
     Trusted: BOOLEAN;          {TRUE, wenn nicht selbst connected wird.}
   END;

{$ENDIF}

VAR ChannelDatRoot: pChanRec;
    OwnConvData: pConvOwnData;
{$IFDEF CONVNETZ}
    HostDataRoot: pHostListe;
    ExtUserRoot: pExtUser;
    DestiRoot: pDesti;
{$ENDIF}

IMPLEMENTATION
END.
