(****************************************************************************)
(* ONLINE-Hilfe fr MCUT.                                                   *)
(* von DG4MMI, tnx Jonny                                                    *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4MMI                                                                   *)
(*                                                                          *)
(* Changelog:                                                               *)
(*    Herbst 95: Name von HELP.PAS in ONLHELP.PAS gendert,                 *)
(*               DG4IAD.                                                    *)
(*    7.2.96   : Speicher wird nur noch alloziert, wenn er gebraucht wird.  *)
(*               Neue Procedure GetMemory und Variable MemoryOK:BOOLEAN;    *)
(*               DG4IAD.                                                    *)
(*   18.2.96   : Fehlermeldung, wenn HELP nicht DEFINED ist                 *)
(*               DG4IAD                                                     *)
(*   13.3.96   : Einbindung von KEYMAKRO zum Aufnehmen/Abspielen von        *)
(*               Tastaturmakros. KeyPressed/Readkey durch Xkeypressed       *)
(*               /XReadKey ersetzt                                          *)
(*               DG4IAD                                                     *)
(*   09.4.97   : Anpassung an veraenderte Bildschirm-Ausgabe, leider wurde  *)
(*               bei der Hilfe-Unit des MCUT-Video-Kernel vielfach umgangen *)
(*               deswegen sind die Aenderungen umfangreicher als in anderen *)
(*               MCUT-Units.  DG4IAD                                        *)
(****************************************************************************)
{$IFNDEF HELP} fehler! {$ENDIF}

UNIT OnlHelp;

Interface

CONST MemoryOK:BOOLEAN=FALSE;
CONST HelpVersion='1.0';
VAR HelpLines: Byte;
    HelpDir: String[70];
PROCEDURE GetMemory;
Procedure ReleaseMemory;
Procedure SetHelpColors(BG, FG, FG2, MBG, MFG: Byte);
Procedure LoadHelpFile(HelpFile: String);
Function SelectHelpFile: Boolean;
Function HelpIndex: Boolean;
Function ViewHelp(Topic: String): Boolean;
Function HelpHandleKey: Boolean;

Implementation
USES Crt, Dos, Video, KeyMakro;
TYPE String250=Array[1..250, 1..5] of String[30];
     Word250=Array[1..250] of Word;
     Longint5000=Array[1..5000] of Longint;
     Byte5000=Array[1..5000] of Byte;
CONST LetterString=
      'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
VAR HelpFlag: Byte; { 1=Help-Datei whlen, 2=Help-Index, 3=Help anzeigen }

    HelpFiles: Array[1..100] of String[8]; { Namen der Help-Dateien }
    HelpFileNumber: Byte;                  { Anzahl der Help-Dateien }
    HelpFileName: String;                  { Name der gewhlten Help-Datei }

    TopicNumber: Byte;             { Anzahl der Themen in der aktuellen
                                     Help-Datei }
    TopicText: ^String250;         { Alle Themen-berschriften in der
                                     aktuellen Help-Datei}
    TopicLineInfo: ^Word250;       { Offset der Zeileninfos in der
                                     aktuellen Index-Datei }

    CurrentTopic: String[30];      { Das aktuelle Thema }
    CurTopicNumber: Byte;          { Nummer des aktuellen Themas }

    HelpFileLine: ^Longint5000;    { Offset der Zeilen im aktuellen
                                     Hilfe-Thema }
    HelpFileLineLength: ^Byte5000; { Lnge aller Zeilen im aktuellen
                                     Hilfe-Thema }
    TopicLineNumber: Word;         { Anzahl der Zeilen des aktuellen
                                     Hilfe-Themas }

    MaxSynonyms: Byte; { Hchste Anzahl von Synonymen zu einem Thema }

    HelpViewFile: File; { Help-Datei beim Anzeigen eines Hilfe-Themas }

    HelpAbsolutePos: Integer; { Wird beim Anzeigen eines Hilfe-Themas, beim
                             Hilfe-Index und der Help-Datei-Auswahl benutzt }
    HelpScreenPos: Byte;   { Wird beim Anzeigen eines Hilfe-Themas, beim
                             Hilfe-Index und der Help-Datei-Auswahl benutzt }

    OldWindMin: Word; { Zum Speichern und spteren Widerherstellen }
    OldWindMax: Word; { der Window-Daten                           }

    Cursor1, Cursor2: Byte; { Zum Speichern der Cursordaten }

    ColorSet1, ColorSet2, ColorSet3: Byte; { Farbeinstellungen }

    ClearBack: Boolean; { Fr die Rcksprnge }
    BackInfo: String;   { bei ViewHelp        }
    (* Achtung, video.screen zeigt _nicht_ auf den Videospeicher, sondern auf
       MCUTs Pufferbereich ! *)
    segb800:WORD absolute video.screen;

Procedure Ring;
VAR Z: Byte;
BEGIN
FOR Z:=1 TO 10 DO
  BEGIN
  Sound(250);
  Delay(25);
  Sound(500);
  Delay(25);
  END;
NoSound;
END;

Procedure SortTopics;
VAR I, J, S: Integer;
    SwapString: String[30];
    SwapLongint: Longint;
    SwapWord: Word;
    Z: Byte;
BEGIN
S:=TopicNumber div 2;
WHILE S>0 DO
  BEGIN
  FOR I:=S TO TopicNumber-1 DO
    BEGIN
    J:=I-S+1;
    While (J>0) AND (TopicText^[J, 1]>TopicText^[J+S, 1]) DO
      BEGIN
      FOR Z:=1 TO 5 DO
        BEGIN
        SwapString:=TopicText^[J, Z];
        TopicText^[J, Z]:=TopicText^[J+S, Z];
        TopicText^[J+S, Z]:=SwapString;
        END;
      SwapWord:=TopicLineInfo^[J];
      TopicLineInfo^[J]:=TopicLineInfo^[J+S];
      TopicLineInfo^[J+S]:=SwapWord;
      Dec(J, S);
      END;
    END;
  S:=S div 2;
  END;
END;

Procedure KillCursor;
VAR Reg: Registers;
BEGIN
Reg.AH:=3;
Intr($10, Reg);
Cursor1:=Reg.CL;
Cursor2:=Reg.CH;
Reg.AH:=1;
Reg.CL:=0;
Reg.CH:=32;
Intr($10, Reg);
END;

Procedure RestoreCursor;
VAR Reg: Registers;
BEGIN
Reg.AH:=1;
Reg.CL:=Cursor1;
Reg.CH:=Cursor2;
Intr($10, Reg)
END;

Procedure SaveWindowData;
BEGIN
OldWindMin:=WindMin;
OldWindMax:=WindMax;
END;

Procedure RestoreWindowData;
BEGIN
Window(Lo(OldWindMin)+1, Hi(OldWindMin)+1,
       Lo(OldWindMax)+1, Hi(OldWindMax)+1);
END;

Function GetCode(X, Y, Offset: Byte): Byte;
BEGIN
GetCode:=(Byte(Ptr(SegB800, ((Y-1)*80+X-1)*2+Offset)^));
END;

Procedure SetCode(X, Y, Offset, Sign: Byte);
BEGIN
Byte(Ptr(SegB800, ((Y-1)*80+X-1)*2+Offset)^):=Sign;
END;

Procedure ChangeIndexMark;
VAR Z, Color: Byte;
BEGIN
IF GetCode(((HelpAbsolutePos-1) mod 2)*34+8, HelpScreenPos, 1)=ColorSet1 THEN
   Color:=ColorSet3
  ELSE
   Color:=ColorSet1;
FOR Z:=0 TO 31 DO
  SetCode(((HelpAbsolutePos-1) mod 2)*34+8+Z, HelpScreenPos, 1, Color)
END;

Procedure ReverseMark;
VAR Color: Byte;
    ActX: Byte;
BEGIN
UpdateScreen;
IF GetCode(WhereX, WhereY, 1)=ColorSet2 THEN
  Color:=ColorSet3
 ELSE
  Color:=ColorSet2;
ActX:=WhereX-1;
Repeat
  Inc(ActX);
  SetCode(ActX, WhereY, 1, Color);
  until (GetCode(ActX+1, WhereY, 1)=ColorSet1) OR (ActX=80);
ActX:=WhereX+1;
Repeat
  Dec(ActX);
  SetCode(ActX, WhereY, 1, Color);
  until (GetCode(ActX-1, WhereY, 1)=ColorSet1) OR (ActX=0);
UpdateBuffer;
END;

Function NoSideSpace(Txt: String): String;
BEGIN
While (Txt[1]=' ') AND (Length(Txt)>1) DO
  Txt:=Copy(Txt, 2, 255);
While (Txt[Length(Txt)]=' ') AND (Length(Txt)>0) DO
  Txt:=Copy(Txt, 1, Length(Txt)-1);
NoSideSpace:=Txt;
END;

Function UpString(Txt: String): String;
VAR C: Byte;
BEGIN
FOR C:=1 TO Length(Txt) DO
  Txt[C]:=UpCase(Txt[C]);
UpString:=Txt;
END;

Function Exists(FileName: String): Boolean;
VAR F: File;
BEGIN
{$I-}
Assign(F, FileName);
Reset(F);
Close(F);
{$I+}
Exists:=(IOResult=0);
END;

Procedure WriteTopicLine(Txt: String);
VAR Z, Z1, Z2: Byte;
BEGIN
IF Length(Txt)>79 THEN Txt[0]:=#79;
Txt:=Txt+StringD(#32, 79-Length(Txt));
PrintS(WhereX, WhereY, Txt, ColorSet1);

ChangeColor(80, WhereY, ColorSet1, 1);
FOR Z:=1 TO TopicNumber DO
  FOR Z1:=1 TO MaxSynonyms DO
    IF (Pos(UpString(TopicText^[Z, Z1]), UpString(Txt))>0) AND
       ((Pos(Chr(GetCode(Pos(UpString(TopicText^[Z, Z1]), UpString(Txt))+
       Length(TopicText^[Z, Z1]), WhereY, 0)), LetterString)=0) OR
       (Pos(UpString(TopicText^[Z, Z1]), UpString(Txt))+
       Length(TopicText^[Z, Z1])=81)) AND
       ((Pos(Chr(GetCode(Pos(UpString(TopicText^[Z, Z1]), UpString(Txt))-1,
       WhereY, 0)), LetterString)=0) OR
       (Pos(UpString(TopicText^[Z, Z1]), UpString(Txt))=1)) AND
       (Z<>CurTopicNumber) THEN
      ChangeColor(Pos(UpString(TopicText^[Z, Z1]), UpString(Txt)),
                  WhereY, ColorSet2,
                  Length(TopicText^[Z, Z1]));
UpdateScreen;
END;

Procedure SetHelpColors(BG, FG, FG2, MBG, MFG: Byte);
BEGIN
ColorSet1:=FG+16*BG;
ColorSet2:=FG2+16*BG;
ColorSet3:=MFG+16*MBG;
END;

Function ViewHelp(Topic: String): Boolean;
VAR IndexFile: File;
    IndexFileName, HelpFileString: String;
    TopicN: Byte;
    Z, Z1: Byte;
    Dummy: Char;
BEGIN
IF not MEMORYOK THEN GetMemory;
IF (HelpFileName='') OR (HelpFlag<>0) THEN
  BEGIN
  ViewHelp:=False;
  Ring;
  Exit;
  END;
IF ClearBack THEN BackInfo:='';
ClearBack:=True;
IndexFileName:=HelpDir+Copy(HelpFileName, 1, Length(HelpFileName)-4)+'.IDX';
TopicN:=0;
FOR Z:=1 TO TopicNumber DO
  FOR Z1:=1 TO 5 DO
    IF UpString(TopicText^[Z, Z1])=UpString(Topic) THEN TopicN:=Z;
IF TopicN>0 THEN
  BEGIN
  IF Length(BackInfo)<255 THEN BackInfo:=BackInfo+Chr(TopicN);
  CurrentTopic:=TopicText^[TopicN, 1];
  CurTopicNumber:=TopicN;
  ViewHelp:=True;
  HelpFlag:=3;
  Assign(IndexFile, IndexFileName);
  Reset(IndexFile, 1);
  Seek(IndexFile, TopicLineInfo^[TopicN]);
  BlockRead(IndexFile, TopicLineNumber, 2);
  FOR Z:=1 TO TopicLineNumber DO
    BEGIN
    BlockRead(IndexFile, HelpFileLine^[Z], 4);
    BlockRead(IndexFile, HelpFileLineLength^[Z], 1);
    END;
  Close(IndexFile);
  Assign(HelpViewFile, HelpDir+HelpFileName);
  Reset(HelpViewFile, 1);
  Seek(HelpViewFile, HelpFileLine^[1]);
  Fill(1, 1, 80, HelpLines, #32, ColorSet1);
  HelpAbsolutePos:=-2;
  HelpScreenPos:=1;
  PrintS((80-Length(CurrentTopic)) div 2, 1,
         CurrentTopic, ColorSet1);
  PrintS((80-Length(CurrentTopic)) div 2-1, 2,
         StringD('=', Length(CurrentTopic)+2), ColorSet1);
  GotoXY(1, 4);
  FOR Z:=1 TO HelpLines-3 DO
    IF Z<=TopicLineNumber THEN
      BEGIN
      BlockRead(HelpViewFile, HelpFileString[1], HelpFileLineLength^[Z]+2);
      HelpFileString[0]:=Chr(HelpFileLineLength^[Z]);
      WriteTopicLine(HelpFileString);
      IF Z<HelpLines THEN GotoXY(1, WhereY+1);
      END;
  GotoXY(1, 1);
  IF GetCode(1, 1, 1)=ColorSet2 THEN ReverseMark;
  END
 ELSE
  BEGIN
  ViewHelp:=False;
  END;
  UpdateScreen;
END;

Function HelpIndex: Boolean;
VAR Z: Byte;
BEGIN
IF not MEMORYOK THEN GetMemory;
IF (HelpFileName='') OR (HelpFlag<>0) THEN
  BEGIN
  HelpIndex:=False;
  Exit;
  END;
HelpIndex:=True;
HelpFlag:=2;
Fill(1, 1, 80, HelpLines, #32, ColorSet1);
KillCursor;
FOR Z:=1 TO 2*HelpLines DO
  IF TopicNumber>=Z THEN
    PrintS(((Z-1) mod 2)*34+9, 1+(Z-1) div 2, TopicText^[Z, 1], ColorSet1);
HelpAbsolutePos:=1;
HelpScreenPos:=1;
ChangeIndexMark;
UpdateScreen;
END;

Procedure ShowHelpInfo;
VAR IndexFile: File;
    HelpInfoString: String;
    Z: Byte;
BEGIN
IF not MEMORYOK THEN GetMemory;
Fill(2, 2+(HelpLines-6) div 2, 31, 6+(HelpLines-6) div 2, #32, ColorSet1);
IF NOT Exists(HelpDir+HelpFiles[HelpAbsolutePos]+'.IDX') THEN
  BEGIN
  PrintS(2, 2+(HelpLines-6) div 2, 'Zu dieser Help-Datei existiert',
                                                                  ColorSet1);
  PrintS(2, 3+(HelpLines-6) div 2, 'keine Index-Datei.  Bitte eine',
                                                                  ColorSet1);
  PrintS(2, 4+(HelpLines-6) div 2, 'Index-Datei mit MAKEIDX.EXE am',
                                                                  ColorSet1);
  PrintS(2, 5+(HelpLines-6) div 2, 'DOS-Prompt erzeugen.', ColorSet1);
  END
 ELSE
  BEGIN
  Assign(IndexFile, HelpDir+HelpFiles[HelpAbsolutePos]+'.IDX');
  Reset(IndexFile, 30);
  IF FileSize(IndexFile)<4 THEN
    BEGIN
    Ring;
    Close(IndexFile);
    Exit;
    END;
  HelpInfoString[0]:=#30;
  FOR Z:=1 TO 4 DO
    BEGIN
    BlockRead(IndexFile, HelpInfoString[1], 1);
    PrintS(2, 1+Z+(HelpLines-6) div 2, HelpInfoString, ColorSet1);
    END;
  Close(IndexFile);
  END;
  UpdateScreen;
END;

Function SelectHelpFile: Boolean;
VAR DirInfo: SearchRec;
    Z: Byte;
BEGIN
IF not MEMORYOK THEN GetMemory;
IF HelpFlag<>0 THEN
  BEGIN
  SelectHelpFile:=False;
  Exit;
  END;
HelpFlag:=1;
HelpFileNumber:=0;
FindFirst(HelpDir+'*.HLP', 39, DirInfo);
IF DosError<>0 THEN
  BEGIN
  Ring;
  HelpFlag:=0;
  Exit;
  END;
While (DosError=0) AND (HelpFileNumber<100) DO
  BEGIN
  Inc(HelpFileNumber);
  HelpFiles[HelpFileNumber]:=Copy(DirInfo.Name, 1, Length(DirInfo.Name)-4);
  FindNext(DirInfo);
  END;
KillCursor;
Fill(1, 1, 80, HelpLines, #32, ColorSet1);
PrintS(34, 2, 'Ŀ', ColorSet1);
FOR Z:=1 TO HelpLines-4 DO
  PrintS(34, 2+Z, '            ', ColorSet1);
PrintS(34, HelpLines-1, '', ColorSet1);
PrintCh(47, 3, #219, ColorSet1);
FOR Z:=2 TO HelpLines-4 DO
  IF HelpFileNumber>=Z THEN
    PrintS(37, 2+Z, HelpFiles[Z], ColorSet1);
PrintS(36, 3, #32+HelpFiles[1]+StringD(#32, 9-Length(HelpFiles[1])),
       ColorSet3);
HelpAbsolutePos:=1;
HelpScreenPos:=1;
ShowHelpInfo;
UpdateScreen;
END;

Procedure LoadHelpFile(HelpFile: String);
VAR IndexFile: File;
    IndexFileName: String;
    HelpFile_: File;
    CheckSize, TopicHeaderOffset: Longint;
    Dummy: Word;
    Z, SynonymNumber: Byte;
    HeaderChar: Char;
BEGIN
IF not MEMORYOK THEN GetMemory;
IndexFileName:=HelpDir+Copy(HelpFile, 1, Length(HelpFile)-4)+'.IDX';
IF NOT Exists(IndexFileName) THEN
  BEGIN
  Ring;
  Exit;
  END;
Assign(HelpFile_, HelpDir+HelpFile);
Reset(HelpFile_, 1);
Assign(IndexFile, IndexFileName);
Reset(IndexFile, 1);
IF FileSize(IndexFile)<168 THEN
  BEGIN
  Close(HelpFile_);
  Close(IndexFile);
  Ring;
  Exit;
  END;
Seek(IndexFile, 120);
BlockRead(IndexFile, CheckSize, 4);
IF CheckSize<>FileSize(HelpFile_) THEN
  BEGIN
  Close(HelpFile_);
  Close(IndexFile);
  Ring;
  Exit;
  END;
BlockRead(IndexFile, TopicNumber, 2);
FOR Z:=1 TO TopicNumber DO
  BEGIN
  BlockRead(IndexFile, TopicHeaderOffset, 4);
  Seek(HelpFile_, TopicHeaderOffset);
  SynonymNumber:=1;
  TopicText^[Z, 1]:='';
  Repeat
    BlockRead(HelpFile_, HeaderChar, 1);
    IF (HeaderChar='@') AND (TopicText^[Z, SynonymNumber]<>'') THEN
      BEGIN
      Inc(SynonymNumber);
      TopicText^[Z, SynonymNumber]:='';
      END;
    IF (HeaderChar<>#13) AND (HeaderChar<>#10) AND (HeaderChar<>'@') THEN
      TopicText^[Z, SynonymNumber]:=TopicText^[Z, SynonymNumber]+HeaderChar;
    until (HeaderChar=#13) OR (HeaderChar=#10);
  IF SynonymNumber>MaxSynonyms THEN MaxSynonyms:=SynonymNumber;
  FOR SynonymNumber:=SynonymNumber TO 5 DO
    TopicText^[Z, SynonymNumber]:='';
  TopicLineInfo^[Z]:=FilePos(IndexFile);
  BlockRead(IndexFile, Dummy, 2);
  Seek(IndexFile, FilePos(IndexFile)+5*Dummy);
  END;
Close(HelpFile_);
Close(IndexFile);
HelpFileName:=HelpFile;
SortTopics;

END;

Procedure SelHelpFileUp;
BEGIN
IF HelpAbsolutePos>1 THEN
  BEGIN
  IF Round(Int(1+((HelpAbsolutePos-2)/HelpFileNumber)*(HelpLines-4)))<>
     Round(Int(1+((HelpAbsolutePos-1)/HelpFileNumber)*(HelpLines-4))) THEN
    BEGIN
    PrintCh(47, 2+Round(Int(1+((HelpAbsolutePos-1)/HelpFileNumber)*
            (HelpLines-4))), #176, ColorSet1);
    PrintCh(47, 2+Round(Int(1+((HelpAbsolutePos-2)/HelpFileNumber)*
            (HelpLines-4))), #219, ColorSet1);
    END;
  PrintS(36, 2+HelpScreenPos, #32+HelpFiles[HelpAbsolutePos]+
         StringD(#32, 9-Length(HelpFiles[HelpAbsolutePos])), ColorSet1);
  IF HelpScreenPos=1 THEN
    BEGIN
    UpdateScreen;
    SaveWindowData;
    Window(36, 3, 46, HelpLines-2);
    TextColor(ColorSet1 mod 16);
    TextBackGround(ColorSet1 div 16);
    InsLine;
    RestoreWindowData;
    UpdateBuffer;
    Dec(HelpAbsolutePos);
    PrintS(36, 3, #32+HelpFiles[HelpAbsolutePos]+
           StringD(#32, 9-Length(HelpFiles[HelpAbsolutePos])), ColorSet3);
    END
     ELSE
    BEGIN
    Dec(HelpAbsolutePos);
    Dec(HelpScreenPos);
    PrintS(36, 2+HelpScreenPos, #32+HelpFiles[HelpAbsolutePos]+
           StringD(#32, 9-Length(HelpFiles[HelpAbsolutePos])), ColorSet3);
    END;
  END;
UpdateScreen;
END;

Procedure SelHelpFileDown;
BEGIN
IF HelpAbsolutePos<HelpFileNumber THEN
  BEGIN
  IF Round(Int(1+(HelpAbsolutePos/HelpFileNumber)*(HelpLines-4)))<>
     Round(Int(1+((HelpAbsolutePos-1)/HelpFileNumber)*(HelpLines-4))) THEN
    BEGIN
    PrintS(47, 2+Round(Int(1+((HelpAbsolutePos-1)/HelpFileNumber)*
           (HelpLines-4))), #176, ColorSet1);
    PrintS(47, 2+Round(Int(1+(HelpAbsolutePos/HelpFileNumber)*
           (HelpLines-4))), #219, ColorSet1);
    END;
  PrintS(36, 2+HelpScreenPos, #32+HelpFiles[HelpAbsolutePos]+
         StringD(#32, 9-Length(HelpFiles[HelpAbsolutePos])),ColorSet1);
  IF HelpScreenPos=HelpLines-4 THEN
    BEGIN
    UpdateScreen;
    SaveWindowData;
    Window(36, 3, 46, HelpLines-2);
    TextColor(ColorSet1 mod 16);
    TextBackGround(ColorSet1 div 16);
    DelLine;
    RestoreWindowData;
    UpdateBuffer;
    Inc(HelpAbsolutePos);
    PrintS(36, HelpLines-2, #32+HelpFiles[HelpAbsolutePos]+
           StringD(#32, 9-Length(HelpFiles[HelpAbsolutePos])),ColorSet3);
    END
   ELSE
    BEGIN
    Inc(HelpAbsolutePos);
    Inc(HelpScreenPos);
    PrintS(36, 2+HelpScreenPos, #32+HelpFiles[HelpAbsolutePos]+
           StringD(#32, 9-Length(HelpFiles[HelpAbsolutePos])), ColorSet3);
    END;
  END;
  UpdateScreen;
END;

Procedure IndexUp;
BEGIN
IF HelpAbsolutePos>2 THEN
  BEGIN
  IF HelpScreenPos=1 THEN
    BEGIN
    ChangeIndexMark;
    UpdateScreen;
    SaveWindowData;
    Window(1, 1, 80, HelpLines);
    TextColor(ColorSet1 mod 16);
    TextBackGround(ColorSet1 div 16);
    InsLine;
    RestoreWindowData;
    UpdateBuffer;
    Dec(HelpAbsolutePos, 2);
    PrintS(9, 1, TopicText^[HelpAbsolutePos-1+
           HelpAbsolutePos mod 2, 1], ColorSet1);
    PrintS(43, 1, TopicText^[HelpAbsolutePos+
           HelpAbsolutePos mod 2, 1], ColorSet1);
    ChangeIndexMark;
    END
   ELSE
    BEGIN
    ChangeIndexMark;
    Dec(HelpScreenPos);
    Dec(HelpAbsolutePos, 2);
    ChangeIndexMark;
    END;
  END;
  UpdateScreen;
END;

Procedure IndexDown;
BEGIN
IF ((HelpAbsolutePos<TopicNumber-1) OR
   ((HelpAbsolutePos mod 2=0) AND (HelpAbsolutePos=TopicNumber-1))) THEN
  BEGIN
  IF HelpScreenPos=HelpLines THEN
    BEGIN
    ChangeIndexMark;
    UpdateScreen;
    SaveWindowData;
    Window(1, 1, 80, HelpLines);
    TextColor(ColorSet1 mod 16);
    TextBackGround(ColorSet1 div 16);
    DelLine;
    RestoreWindowData;
    UpdateBuffer;
    Inc(HelpAbsolutePos, 2);
    IF HelpAbsolutePos>TopicNumber THEN Dec(HelpAbsolutePos);
    PrintS(9, HelpLines, TopicText^[HelpAbsolutePos-1+
           HelpAbsolutePos mod 2, 1], ColorSet1);
    IF NOT ((HelpAbsolutePos=TopicNumber) AND (TopicNumber mod 2=1)) THEN
      PrintS(43, HelpLines, TopicText^[HelpAbsolutePos+
             HelpAbsolutePos mod 2, 1], ColorSet1);
    ChangeIndexMark;
    END
   ELSE
    BEGIN
    ChangeIndexMark;
    Inc(HelpScreenPos);
    Inc(HelpAbsolutePos, 2);
    IF HelpAbsolutePos>TopicNumber THEN Dec(HelpAbsolutePos);
    ChangeIndexMark;
    END;
  END;
END;

Procedure ToggleIndexColumn;
BEGIN
IF NOT ((HelpAbsolutePos=TopicNumber) AND (TopicNumber mod 2<>0)) THEN
  BEGIN
  ChangeIndexMark;
  HelpAbsolutePos:=HelpAbsolutePos-1+2*(HelpAbsolutePos mod 2);
  ChangeIndexMark;
  END;
END;

Procedure HelpViewUp;
VAR SaveX: Byte;
    HelpFileString: String;
BEGIN
IF HelpAbsolutePos>-2 THEN
  BEGIN
  IF GetCode(WhereX, WhereY, 1)=ColorSet3 THEN ReverseMark;
  IF HelpScreenPos=1 THEN
    BEGIN
    UpdateScreen;
    SaveX:=WhereX;
    SaveWindowData;
    Window(1, 1, 80, HelpLines);
    TextColor(ColorSet1 mod 16);
    TextBackGround(ColorSet1 div 16);
    InsLine;
    RestoreWindowData;
    UpdateBuffer;
    Dec(HelpAbsolutePos);
    Case HelpAbsolutePos of
      -2: PrintS((80-Length(CurrentTopic)) div 2, 1,
                 CurrentTopic, ColorSet1);
      -1: PrintS((80-Length(CurrentTopic)) div 2-1, 1,
                 StringD('=', Length(CurrentTopic)+2), ColorSet1);
      0: ;
     ELSE
      Seek(HelpViewFile, HelpFileLine^[HelpAbsolutePos]);
      BlockRead(HelpViewFile, HelpFileString[1],
                HelpFileLineLength^[HelpAbsolutePos]+2);
      HelpFileString[0]:=Chr(HelpFileLineLength^[HelpAbsolutePos]);
      WriteTopicLine(HelpFileString);
      END;
    GotoXY(SaveX, 1);
    END
   ELSE
    BEGIN
    GotoXY(WhereX, WhereY-1);
    Dec(HelpScreenPos);
    Dec(HelpAbsolutePos);
    END;
  IF GetCode(WhereX, WhereY, 1)=ColorSet2 THEN ReverseMark;
  END;
END;

Procedure HelpViewDown;
VAR SaveX: Byte;
    HelpFileString: String;
BEGIN
IF HelpAbsolutePos<TopicLineNumber THEN
  BEGIN
  IF GetCode(WhereX, WhereY, 1)=ColorSet3 THEN ReverseMark;
  IF HelpScreenPos=HelpLines THEN
    BEGIN
    UpdateScreen;
    SaveX:=WhereX;
    SaveWindowData;
    Window(1, 1, 80, HelpLines);
    DelLine;
    RestoreWindowData;
    UpdateBuffer;
    GotoXY(1, HelpLines);
    Inc(HelpAbsolutePos);
    Seek(HelpViewFile, HelpFileLine^[HelpAbsolutePos]);
    BlockRead(HelpViewFile, HelpFileString[1],
              HelpFileLineLength^[HelpAbsolutePos]+2);
    HelpFileString[0]:=Chr(HelpFileLineLength^[HelpAbsolutePos]);
    WriteTopicLine(HelpFileString);
    GotoXY(SaveX, HelpScreenPos);
    END
   ELSE
    BEGIN
    GotoXY(WhereX, WhereY+1);
    Inc(HelpScreenPos);
    Inc(HelpAbsolutePos);
    END;
  IF GetCode(WhereX, WhereY, 1)=ColorSet2 THEN ReverseMark;
  END;
END;

Function HelpHandleKey: Boolean;
VAR Key: Char;
    KeepHelp: Boolean;
    CrossRefString: String;
    Z: Integer;
BEGIN
IF (HelpFlag=0) OR (NOT MemoryOK) THEN
  BEGIN
  HelpHandleKey:=False;
  Exit;
  END;
IF NOT KeyPressed THEN
  BEGIN
  HelpHandleKey:=True;
  Exit;
  END;
KeepHelp:=True;
Case HelpFlag of
  1: BEGIN
     Key:=XReadKey;
     Case Key of
     #0: BEGIN
         Key:=Xreadkey;
         Case Key of
           #72, #74: SelHelpFileUp;
           #80, #77: SelHelpFileDown;
           #73: FOR Z:=1 TO HelpLines-5 DO
                  SelHelpFileUp;
           #81: FOR Z:=1 TO HelpLines-5 DO
                  SelHelpFileDown;
           #71, #119, #132: FOR Z:=HelpAbsolutePos DOWNTO 1 DO
                              SelHelpFileUp;
           #79, #117, #118: FOR Z:=HelpAbsolutePos TO HelpFileNumber DO
                              SelHelpFileDown;
           END;
         ShowHelpInfo;
         Key:=#0;
         END;
     #27: BEGIN
          KeepHelp:=False;
          HelpFlag:=0;
          RestoreCursor;
          END;
     #13: BEGIN
          LoadHelpFile(HelpFiles[HelpAbsolutePos]+'.HLP');
          KeepHelp:=False;
          HelpFlag:=0;
          RestoreCursor;
          END;
       END;
     END;
  2: BEGIN
     Key:=Xreadkey;
     Case Key of
     #0: BEGIN
         Key:=Xreadkey;
         Case Key of
           #77, #75: ToggleIndexColumn;
           #72: IndexUp;
           #80: IndexDown;
           #73: FOR Z:=1 TO HelpLines-1 DO
                  IndexUp;
           #81: FOR Z:=1 TO HelpLines-1 DO
                  IndexDown;
           #71, #119, #132: FOR Z:=HelpAbsolutePos div 2 DOWNTO 1 DO
                              IndexUp;
           #79, #117, #118: FOR Z:=HelpAbsolutePos div 2 TO TopicNumber DO
                              IndexDown;
           END;
         Key:=#0;
         END;
     #27: BEGIN
          KeepHelp:=False;
          HelpFlag:=0;
          RestoreCursor;
          END;
     #13: BEGIN
          HelpFlag:=0;
          RestoreCursor;
          IF ViewHelp(TopicText^[HelpAbsolutePos, 1])=False THEN
            BEGIN
            Ring;
            HelpFlag:=2;
            KillCursor;
            END;
          END;
     'A'..'Z', 'a'..'z': BEGIN
                         Key:=UpCase(Key);
                         Z:=1;
                         While (Key>Copy(TopicText^[Z, 1], 1, 1)) AND
                               (Z<TopicNumber) DO
                         Inc(Z);
                         IF ((Z+1) div 2)<((HelpAbsolutePos+1) div 2) THEN
                           Repeat
                             IndexUp;
                             until ((Z+1) div 2)=((HelpAbsolutePos+1) div 2);
                         IF ((Z+1) div 2)>((HelpAbsolutePos+1) div 2) THEN
                           Repeat
                             IndexDown;
                             until ((Z+1) div 2)=((HelpAbsolutePos+1) div 2);
                         IF HelpAbsolutePos<>Z THEN ToggleIndexColumn;
                         END;
       END;
     END;
  3: BEGIN
     Key:=Xreadkey;
     Case Key of
     #0: BEGIN
         Key:=Xreadkey;
         Case Key of
           #77: IF WhereX<80 THEN
                  BEGIN
                  IF (GetCode(WhereX, WhereY, 1)=
                                        ColorSet3)
                     AND (GetCode(WhereX+1, WhereY, 1)=
                                               ColorSet1) THEN
                    ReverseMark;
                  GotoXY(WhereX+1, WhereY);
                  IF GetCode(WhereX, WhereY, 1)=ColorSet2 THEN
                    ReverseMark;
                  END;
           #75: IF WhereX>0 THEN
                  BEGIN
                  IF (GetCode(WhereX, WhereY, 1)=ColorSet3)
                     AND (GetCode(WhereX-1, WhereY, 1)=ColorSet1) THEN
                    ReverseMark;
                  GotoXY(WhereX-1, WhereY);
                  IF GetCode(WhereX, WhereY, 1)=ColorSet2 THEN
                    ReverseMark;
                  END;
           #72: HelpViewUp;
           #80: HelpViewDown;
           #73: FOR Z:=1 TO HelpLines-1 DO
                  HelpViewUp;
           #81: FOR Z:=1 TO HelpLines-1 DO
                  HelpViewDown;
           #71: IF WhereX>1 THEN
                  BEGIN
                  IF GetCode(WhereX, WhereY, 1)=ColorSet3 THEN
                    ReverseMark;
                  GotoXY(1, WhereY);
                  IF GetCode(1, WhereY, 1)=ColorSet2 THEN
                    ReverseMark;
                  END;
           #79: BEGIN
                IF GetCode(WhereX, WhereY, 1)=ColorSet3 THEN
                ReverseMark;
                Z:=80;
                While (GetCode(Z-1, WhereY, 0)=32) AND (Z>1) DO
                  Dec(Z);
                GotoXY(Z, WhereY);
                END;
           #119, #132: FOR Z:=HelpAbsolutePos DOWNTO -2 DO
                         HelpViewUp;
           #117, #118: FOR Z:=HelpAbsolutePos TO TopicLineNumber DO
                         HelpViewDown;
           END;
         Key:=#0;
         END;
     #13: IF (GetCode(WhereX, WhereY, 1)=ColorSet3) THEN
            BEGIN
            Z:=Z;
            While (GetCode(WhereX-1, WhereY, 1)<>ColorSet1)
                  AND (WhereX>1) DO
              GotoXY(WhereX-1, WhereY);
            CrossRefString:='';
            Repeat
              CrossRefString:=CrossRefString+Chr(GetCode(WhereX, WhereY, 0));
              GotoXY(WhereX+1, WhereY);
              until (GetCode(WhereX, WhereY, 1)=ColorSet1) OR
                    (WhereX=80);
            HelpFlag:=0;
            Close(HelpViewFile);
            ClearBack:=False;
            IF ViewHelp(CrossRefString)=False THEN
              BEGIN
              ClearBack:=True;
              HelpFlag:=3;
              GotoXY(Z, WhereY);
              Ring;
              Reset(HelpViewFile, 1);
              END;
            END;
     #27: BEGIN
          Close(HelpViewFile);
          HelpFlag:=0;
          KeepHelp:=False;
          END;
     #32, 'I', 'i': BEGIN
                    Close(HelpViewFile);
                    HelpFlag:=0;
                    HelpIndex;
                    END;
     #8, 'Z', 'z': BEGIN
                   IF BackInfo[0]=#1 THEN
                     BEGIN
                     Close(HelpViewFile);
                     HelpFlag:=0;
                     HelpIndex;
                     END
                    ELSE
                     BEGIN
                     Close(HelpViewFile);
                     HelpFlag:=0;
                     ClearBack:=False;
                     BackInfo:=Copy(BackInfo, 1, Length(BackInfo)-1);
                     ViewHelp(TopicText^[Ord(BackInfo[Length(BackInfo)]), 1]);
                     BackInfo:=Copy(BackInfo, 1, Length(BackInfo)-1);
                     END;
                   END;
       END;
    END;
  END;
UpdateScreen;  
HelpHandleKey:=KeepHelp;
END;

Procedure ReleaseMemory;
BEGIN
IF NOT MemoryOK THEN exit;
Dispose(TopicText);
Dispose(TopicLineInfo);
Dispose(HelpFileLine);
Dispose(HelpFileLineLength);
MemoryOK:=FALSE;
END;


PROCEDURE GetMemory;
BEGIN
IF MemoryOK THEN exit;
HelpFlag:=0;
HelpFileName:='';
ClearBack:=True;
MaxSynonyms:=1;
New(TopicText);
New(TopicLineInfo);
New(HelpFileLine);
New(HelpFileLineLength);
MemoryOK:=TRUE
END;

BEGIN
END.
