(****************************************************************************)
(* Zeitgesteuerte Ausfhrung bestimmter Aktionen.                           *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(****************************************************************************)

UNIT CRON;

INTERFACE

PROCEDURE StartTask(var S:STRING);
PROCEDURE Do_Cron;

IMPLEMENTATION
USES IADVAR,BOXMAIN,DOS,MYSTRING;


VAR
    c:BYTE;
    pcron:pcrondata;
    lastcron,atag,monat,ajahr,stunde,minute,sekunde,awochentag:WORD;
    DoIt:BOOLEAN;

(***************************************************************************)
(*  StartTask startet eine virtuelle Verbindung zur Mailbox und legt       *)
(*  die S in die ReceiveQueue. fngt s mit ^ an, dann wird die Datei       *)
(*  die hinter ^steht in die Queue geladen.                                *)
(*  Wird fr die CRONTAB gebraucht.                                        *)
(***************************************************************************)

PROCEDURE StartTask(var S:STRING);
VAR b,chan,schachtel:BYTE;

PROCEDURE LoadFile(s:string);
var zeile:string;f:text;
BEGIN
  {$I-}
  inc(schachtel);
  IF schachtel>5 THEN exit;
  Assign(f,copy(s,2,255));
  Reset(f);
  IF (IOResult>0) OR (EOF(f)) THEN
    Exit;
  WHILE NOT(eof(f)) DO
  BEGIN
    ReadLn(f,zeile);
    b:=ioresult;
    IF (S[1]='^') THEN
     Loadfile(zeile) ELSE
    PushQueue(KS[chan]^.ReceiveQueue,0,zeile);
  END;
  CLOSE(f);
  dec(schachtel);
END;

BEGIN
  chan:=0;
  schachtel:=0;
  FOR B:=1 To 255 DO
    IF KS[b]=NIL THEN chan:=b;
  IF CHAN>0 THEN
  BEGIN
    NewKS(chan);
    KS[chan]^.FLAGS:=KS[chan]^.FLAGS OR KS_CRONTask;
    MCall[chan]^:=BoxCall;
    KS[chan]^.Call:=SystemCall;
    IF (S[1]='<') OR (S[1]='^') THEN
    BEGIN
      loadfile(s);
    END ELSE
    PushQueue(KS[chan]^.ReceiveQueue,0,s);
    KS[chan]^.status:=50;
    KS[chan]^.lev:=15;
    KS[chan]^.name:='';
    Box_Login(chan);
  END;
END;

(***************************************************************************)
(*   Hier wird jede Minute die im Speicher befindliche CRONTAB ausgewertet *)
(*   und ggf eine Aktion ausgefhrt                                        *)
(***************************************************************************)

PROCEDURE Do_Cron;
label point;
BEGIN
  pcron:=cronlist;
  gettime(stunde,minute,sekunde,awochentag);
  if minute=lastcron Then exit;
  lastcron:=minute;
  getdate(atag,monat,ajahr,awochentag);
  WHILE (pcron^.next<>NIL) DO
  BEGIN
    pcron:=pcron^.next;
    DoIt:=TRUE;
    WITH pcron^ DO
    BEGIN
      IF (min[0]<>#1) OR (min[1]<>'*') THEN
      BEGIN
        ein_s:=ConvertByteToString(minute);
        IF (min[1]<>'*') and (min[1]<>ein_s[1]) THEN
          DoIt:=FALSE
        ELSE
        IF (min[0]=#2) and (min[2]<>'*') and (min[2]<>ein_s[2]) THEN
          DoIt:=FALSE;
      END;
      IF not DoIt THEN Goto point;
      IF (std[0]<>#1) OR (std[1]<>'*') THEN
      BEGIN
        ein_s:=ConvertByteToString(stunde);
        IF (std[1]<>'*') and (std[1]<>ein_s[1]) THEN
          DoIt:=FALSE
        ELSE
        IF (std[0]=#2) and (std[2]<>'*') and (std[2]<>ein_s[2]) THEN
          DoIt:=FALSE;
      END;
      IF not DoIt THEN Goto point;
      IF (tag[0]<>#1) OR (tag[1]<>'*') THEN
      BEGIN
        ein_s:=ConvertByteToString(atag);
        IF (tag[1]<>'*') and (tag[1]<>ein_s[1]) THEN
          DoIt:=FALSE
        ELSE
        IF (tag[0]=#2) and (tag[2]<>'*') and (tag[2]<>ein_s[2]) THEN
          DoIt:=FALSE;
      END;
      IF not DoIt THEN Goto point;
      IF (mon[0]<>#1) OR (mon[1]<>'*') THEN
      BEGIN
        ein_s:=ConvertByteToString(monat);
        IF (mon[1]<>'*') and (mon[1]<>ein_s[1]) THEN
          DoIt:=FALSE
        ELSE
        IF (mon[0]=#2) and (mon[2]<>'*') and (mon[2]<>ein_s[2]) THEN
          DoIt:=FALSE;
      END;
      IF not DoIt THEN Goto point;
      IF (jahr[0]<>#1) OR (jahr[1]<>'*') THEN
      BEGIN
        ein_s:=ConvertByteToString(ajahr);
        IF (jahr[1]<>'*') and (jahr[1]<>ein_s[1]) THEN
          DoIt:=FALSE
        ELSE
        IF (jahr[0]=#2) and (jahr[2]<>'*') and (jahr[2]<>ein_s[2]) THEN
          DoIt:=FALSE;
      END;
      IF not DoIt THEN Goto point;
      IF (wochentag[0]<>#1) OR (wochentag[1]<>'*') THEN
      BEGIN
        ein_s:=ConvertByteToString(awochentag);
        IF (wochentag[1]<>'*') and (wochentag[1]<>ein_s[1]) THEN
          DoIt:=FALSE
        ELSE
        IF (wochentag[0]=#2) and (wochentag[2]<>'*') and (wochentag[2]<>ein_s[2]) THEN
          DoIt:=FALSE;
      END;
      IF DoIt THEN
      StartTask(pcron^.aktion^);
  point:

    END;
  END;
END;

END.