UNIT linux_serial;

(*  MCUT - a Packet-Radio terminal/bbs/convers-bridge for DOS and LinuX
 *  Copyright (C) 1997 by Hans-Peter Zorn
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This Unit interfaces the serial ports or the TFKISS under LinuX
 *)

INTERFACE

FUNCTION TFKISS_Open(tfkiss_path:string):BOOLEAN;
FUNCTION TFKISS_Install(tfkiss_path:string):BOOLEAN;
PROCEDURE TFKISS_SER_Close;
FUNCTIOn TFKISS_SER_DataAvail:BOOLEAN;
FUNCTION TFKISS_SER_Read:CHAR;
PROCEDURE TFKISS_SER_Write(ch: CHAR);
FUNCTION SER_Open(dev : STRING;speed:LONGINT):BOOLEAN;
FUNCTION SER_Install(dev : STRING):BOOLEAN;

IMPLEMENTATION
{ $i syscalls.inc}
USES sockets,linux,strings,screen,iadvar,crt,toolbox;
VAR serialfd:LONGINT;


FUNCTION TFKISS_Open(tfkiss_path: STRING):BOOLEAN;
VAR
  ServAddr:TUnixSockAddr;
  ServLen:LONGINT;sin,sout:text;
  S:STRING;
BEGIN
  serialfd:=socket(AF_UNIX,SOCK_STREAM,0);
  servaddr.family:=AF_UNIX;
  {move(tfkiss_path[1],servaddr.sun_path,length(tfkiss_path));}
  StrPCopy(servaddr.path,tfkiss_path);
  servlen:=length(tfkiss_path)+3;
  {saddr:=pSockAddr(@servaddr);
  serialfd:=socket(saddr^.sa_family,SOCK_STREAM,0);}
  TFKISS_open:=TRUE;
  sockets.connect(serialfd,ServAddr,servlen,sin,sout);

  if SocketError<>0 THEN
  BEGIN
    fdclose(serialfd);
    str(SocketError,s);
    popup('connect:'+s);
     
    TFKISS_open:=FALSE;
  END;
END; { TFKISS_Open }

FUNCTION TFKISS_Install(tfkiss_path: STRING):BOOLEAN;
VAR
  ServAddr:TUnixSockAddr;
  ServLen:LONGINT;sin,sout:text;
BEGIN
  serialfd:=socket(AF_UNIX,SOCK_STREAM,0);
  servaddr.family:=AF_UNIX;
  {move(tfkiss_path[1],servaddr.sun_path,length(tfkiss_path));}
  StrPCopy(servaddr.path,tfkiss_path);
  servlen:=length(tfkiss_path)+3;
  {saddr:=pSockAddr(@servaddr);
  serialfd:=socket(saddr^.sa_family,SOCK_STREAM,0);}
  sockets.connect(serialfd,ServAddr,servlen,sin,sout);
  iF SocketError<>0 THEN
  BEGIN
    fdclose(serialfd);
   { str(SocketError,s);
    popup('connect:'+s);
    drv_typ:=NOT_ATTACHED;}
  END;
  if serialfd<0 THEN 
  BEGIN
    tfkiss_Install:=FALSE;
    exit;
  END;  
   fdclose(serialfd);
  tfkiss_install:=TRUE;
END; { TFKISS_Install }
  


PROCEDURE TFKISS_SER_Close;
BEGIN
  fdclose(serialfd);
END; { TFKISS_SER_Close }



FUNCTION  TFKISS_SER_DataAvail:BOOLEAN;
VAR FD : FDSet;test:PFDset;TRec:TimeVal
BEGIN

   FD_ZERO(FD);
   FD_SET(serialFD,FD);
   TRec.Sec := 0;
   TRec.USec := 1000;
   test:=@FD;
   TFKISS_SER_DataAvail:=select(serialfd+1,test,NIL,NIL,@Trec)<>0;
{$IFDEF asbach}
    {okok, spaeter kommt da ein highlevel select()-aufruf hin, wenn
     er implementiert ist...}
  {<EXTREMELY_DIRTY_HACK>}
  For i := 0 to 31 Do
    FDS[i] := 0;
  FDS[serialfd div (sizeof(longint)*8)] := (1 shl (serialfd mod
					    (sizeof(longint)*8)));
  SelectArray[1] := serialfd+1;
  SelectArray[2] := LongInt(@FDS);
  SelectArray[3] := 0;
  SelectArray[4] := 0;
  SelectArray[5] := LongInt(@TRec);
  Regs.reg2 := LongInt(@SelectArray);
  TFKISS_SER_DataAvail := (SysCall(Syscall_nr_select, regs) <> 0);
  {</EXTREMELY_DIRTY_HACK>}
{$ENDIF}
END; { TFKISS_SER_DataAvail }
     

FUNCTION TFKISS_SER_Read:    CHAR;
VAR ch:CHAR;
BEGIN
  fdread(serialfd,@ch,1);
  TFKISS_SER_Read:=ch;
END; { TFKISS_SER_Read }
   

PROCEDURE TFKISS_SER_Write(ch: CHAR);
BEGIN
  if fdwrite(serialfd,@ch,1)<0 THEN
  BEGIN
    tfkiss_ser_close;
    tnc_an:=FALSE;
    popup('lost connection to tnc');
  END;
END; { TFKISS_SER_Write }
{$PACKRECORDS 1}
VAR old_termios,new_termios : TermIOS;

FUNCTION SER_Open(dev : STRING;speed:LONGINT):BOOLEAN;

VAR   serialdev_path : STRING;
   err		     : LONGINT;
   pc		     : ARRAY[0..255] OF CHAR;
   speed2	     : LONGINT;
BEGIN
   SER_Open:=FALSE;
   strPcopy(pc,dev);
   serialfd:=fdopen(dev,OPEN_RDWR,0);
   err:=errno; 
   {textcolor(1);}
   if serialfd<0 THEN
   BEGIN
      WriteLn('serialfd:',err);
      exit;
   END;
   fillchar(old_termios,sizeof(old_termios),0);
  IF not tcgetattr(serialfd,old_termios) THEN
   BEGIN
      {WriteLn('tcgetattr:',tcgetattr(serialfd,old_termios));readlN;}
      fdclose(serialfd);exit;
   END;
   tcsetattr(serialfd,TCSADRAIN,old_termios);
   new_termios:=old_termios;
   tcsetattr(serialfd,TCSADRAIN,new_termios);
   WITH old_termios DO
   BEGIN
      c_cc[VTIME]:=0;
      c_cc[VMIN]:=0;
      c_iflag:=0;
      c_iflag:=c_iflag OR IGNBRK;
      c_cflag:=c_cflag OR (CS8 OR CREAD OR CLOCAL);
      c_lflag:=0;
      c_cflag:=c_cflag AND NOT(CSTOPB OR PARENB OR PARODD OR HUPCL);
   END;
   tcsetattr(serialfd,TCSADRAIN,new_termios);
   
  { writeln(xhex(old_termios.c_cflag));READLN;}
   speed2:=B19200;
   IF speed=9600 THEN speed2:=B9600
   ELSE IF speed=19200 THEN speed2:=B19200
   ELSE IF speed=38400 THEN speed2:=B38400;
   cfsetispeed(new_termios,speed2);
   cfsetospeed(new_termios,speed2);
  { writeln(xhex(old_termios.c_cflag));READLN;}

   
   new_termios.c_cflag:=new_termios.c_cflag AND NOT CBAUD;
   new_termios.c_cflag:=new_termios.c_cflag OR speed2;
   if not tcsetattr(serialfd,TCSADRAIN,old_termios) THEN
   BEGIN
      fdclose(serialfd);exit;
   END;
   SER_Open:=TRUE;
END; { SER_Open }
   

FUNCTION SER_Install(dev : STRING):BOOLEAN;
BEGIN
   SER_INSTALL:=SER_Open(dev,9600);
   {SER_INSTALL:=TRUE;}
   IF Ser_Install THEN
      fdclose(serialfd);
END; { SER_Install }

END.

























































