UNIT termios;
(* quick and dirty conversion of termios.h - not portable at all :-( *)
(* (c) 1997 Hans-Peter Zorn *)
INTERFACE
{$PACKRECORD 1}
TYPE
   PTermIOS = ^TTermIOS;
   TTermIOS = RECORD 
		c_iflag	: LONGINT;
		c_oflag	: LONGINT;
		c_cflag	: LONGINT;
		c_lflag	: LONGINT;
		c_line	: CHAR;
		c_cc	: ARRAY[0..18] OF BYTE;
		{ dummy	: ARRAY[0..255] OF BYTE;}
	     END;	
{$PACKRECORD 2}	   
FUNCTION tcgetattr(filedes : LONGINT; termios_p: PTermIOS):LONGINT;
FUNCTION tcsetattr(filedes : LONGINT; optional_actions :LONGINT;
		   termios_p : PTermIOS ): LONGINT;
FUNCTION cfsetispeed(termios_p : PTermIOS; speed : LONGINT):LONGINT;
FUNCTION cfsetospeed(termios_p : PTermIOS; speed:LONGINT):LONGINT;

CONST
   VINTR  = 0;
   VQUIT  = 1;
   VERASE = 2;
   VKILL	  = 3;
   VEOF	  = 4;
   VTIME	  = 5;
   VMIN	  = 6;
   VSWTC	  = 7;
   VSTART	  = 8;
   VSTOP	  = 9;
   VSUSP	  = 10;
   VEOL	  = 11;
   VREPRINT = 12;
   VDISCARD = 13;
   VWERASE  = 14;
   VLNEXT	  = 15;
   VEOL2	  = 16;


IGNBRK =	0000001;
   BRKINT=	0000002;
   IGNPAR=	0000004;
   PARMRK=	0000010;
   INPCK=	0000020;
   ISTRIP=	0000040;
   INLCR=	0000100;
   IGNCR=	0000200;
   ICRNL=	0000400;
   IUCLC=	0001000;
   IXON=	0002000;
   IXANY=	0004000;
   IXOFF=	0010000;
   IMAXBEL=	0020000;


OPOST=	0000001;
   OLCUC=	0000002;
   ONLCR=	0000004;
   OCRNL=	0000010;
   ONOCR=	0000020;
   ONLRET=	0000040;
   OFILL=	0000100;
   OFDEL=	0000200;
   NLDLY=	0000400;
   NL0=	0000000;
   NL1=	0000400;
   CRDLY=	0003000;
   CR0=	0000000;
   CR1=	0001000;
   CR2=	0002000;
   CR3=	0003000;
   TABDLY=	0014000;
   TAB0=	0000000;
   TAB1=	0004000;
   TAB2=	0010000;
   TAB3=	0014000;
   XTABS=	0014000;
   BSDLY=	0020000;
   BS0=	0000000;
   BS1=	0020000;
   VTDLY=	0040000;
   VT0=	0000000;
   VT1=	0040000;
   FFDLY=	0100000;
   FF0=	0000000;
   FF1=	0100000;


   CBAUD=	0010017;
   B0=	0000000;
   B50=	0000001;
   B75=	0000002;
   B110=	0000003;
   B134=	0000004;
   B150=	0000005;
   B200=	0000006;
   B300=	0000007;
   B600=	0000010;
   B1200=	0000011;
   B1800=	0000012;
   B2400=	0000013;
   B4800=	0000014;
   B9600=	0000015;
   B19200=	0000016;
   B38400=	0000017;
   EXTA= B19200;
   EXTB= B38400;
   CSIZE=	0000060;
   CS5=	0000000;
   CS6=	0000020;
   CS7=	0000040;
   CS8=	0000060;
   CSTOPB=	0000100;
   CREAD=	0000200;
   PARENB=	0000400;
   PARODD=	0001000;
   HUPCL=	0002000;
   CLOCAL=	0004000;
   CBAUDEX= 0010000;
   B57600=  0010001;
   B115200= 0010002;
   B230400= 0010003;
   B460800= 0010004;
   CIBAUD=	  002003600000;	
   CMSPAR=	  010000000000;	
   {CRTSCTS=	  020000000000L;} (* oups, must fix that! *)	


   ISIG=	0000001;
   ICANON=	0000002;
   XCASE=	0000004;
   ECHO=	0000010;
   ECHOE=	0000020;
   ECHOK=	0000040;
   ECHONL=	0000100;
   NOFLSH=	0000200;
   TOSTOP=	0000400;
   ECHOCTL=	0001000;
   ECHOPRT=	0002000;
   ECHOKE=	0004000;
   FLUSHO=	0010000;
   PENDIN=	0040000;
   IEXTEN=	0100000;


   TCOOFF=		0;
   TCOON=		1;
   TCIOFF=		2;
   TCION=		3;


   TCIFLUSH=	0;
   TCOFLUSH=	1;
   TCIOFLUSH=	2;


   TCSANOW=		0;
   TCSADRAIN=	1;
   TCSAFLUSH=	2;

FUNCTION cfmakeraw(t : pTermIOS):LONGINT;
FUNCTION tcflush(filedes : LONGINT):LONGINT;
FUNCTION tcsetpgrp(filedes : LONGINT; pgrp_id:LONGINT):LONGINT;
FUNCTION tcdrain(filedes : LONGINT;action:LONGINT):LONGINT;
FUNCTION tcflow(filedes	: LONGINT;queue_selection:LONGINT):LONGINT;

IMPLEMENTATION   
USES Syscalls;

FUNCTION cfmakeraw(t : pTermIOS):LONGINT; [ C ];
FUNCTION tcflush(filedes : LONGINT):LONGINT; [ C ];
FUNCTION tcsetpgrp(filedes : LONGINT; pgrp_id:LONGINT):LONGINT; [ C ];
FUNCTION tcdrain(filedes : LONGINT;action:LONGINT):LONGINT;[ C ];
FUNCTION tcflow(filedes	: LONGINT;queue_selection:LONGINT):LONGINT;[ C ];

{FUNCTION tcgetattr(filedes : LONGINT; termios_p: PTermIOS):LONGINT; [ C ];
FUNCTION tcsetattr(filedes : LONGINT; optional_actions :LONGINT;
		   termios_p : PTermIOS ): LONGINT; [ C ];}

FUNCTION tcgetattr(filedes : LONGINT; termios_p: PTermIOS):LONGINT;
VAR REG	: syscallregs;
BEGIN
   reg.ebx:=filedes;
   reg.ecx:=$5401;
   reg.edx:=longint(termios_p);
   tcgetattr:=syscall(syscall_nr_ioctl,reg);
END;   

FUNCTION tcsetattr(filedes : LONGINT; optional_actions :LONGINT;
		   termios_p : PTermIOS ): LONGINT; 
VAR REG	: syscallregs;
BEGIN
  CASE optional_actions OF
    TCSANOW   : reg.ecx:=$5402;
    TCSADRAIN : reg.ecx:=$5403;
    TCSAFLUSH : reg.ecx:=$5404;
  END; { case }
  reg.ebx:=filedes;
  reg.edx:=longint(termios_p);
  tcsetattr:=syscall(syscall_nr_ioctl,reg);
END;
{FUNCTION cfsetispeed(termios_p : PTermIOS; speed : LONGINT):LONGINT;[ C ];
FUNCTION cfsetospeed(termios_p : PTermIOS; speed:LONGINT):LONGINT;[ C ];
}
FUNCTION cfsetispeed(termios_p : PTermIOS; speed : LONGINT):LONGINT;
BEGIN
  termios_p^.c_cflag:=termios_p^.c_cflag AND NOT CBAUD;
  termios_p^.c_cflag:=termios_p^.c_cflag OR speed;

END;
FUNCTION cfsetospeed(termios_p : PTermIOS; speed:LONGINT):LONGINT;
BEGIN
  cfsetispeed(termios_p,speed);
END;


END.














