(****************************************************************************)
(* BBS-Auswahl-Liste fr MCUT.                                              *)
(*                                                                          *)
(* Die Unit darf als Overlay deklariert werden.                             *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(* IAD, feb 96,jan 97,dez 97                                                *)
(****************************************************************************)

UNIT BBSList;

INTERFACE

  PROCEDURE InitList(channel:byte);
  PROCEDURE KillList;
  PROCEDURE BBSListHandleKey;
  PROCEDURE BBSListReDraw;
  PROCEDURE BBSListHandle(VAR S:STRING);

IMPLEMENTATION

USES IADVAR,VIDEO,TOOLBOX,MYSTRING,KEYMAKRO;
CONST fBBSList=7;fBBSListHighLight=112;
      
TYPE
   pListRec=^tListRec;
   tListRec=RECORD
      RUBRIK:STRING8;
      Nummer:WORD;
      Titel:STRING40;
      Absender:STRING6;
      Datum,Groesse:LONGINT;
      bid:string12;
      Markiert:BOOLEAN;
   END;
   tListArray=ARRAY[1..1000] OF pListRec;

CONST Aktiv:BOOLEAN=FALSE;

VAR
  ListArray:^tListArray;
  Zeile,FirstLine,AnzLine:WORD;
  Reference:BYTE;
  BBSListWinSize:BYTE;

PROCEDURE InitList(channel:byte);
BEGIN
  IF Aktiv THEN
    KillList;
  NEW(ListArray);
  Zeile:=1;Firstline:=1;
  BBSListWinSize:=_zeilen;
  AnzLine:=0;
END;

PROCEDURE KillList;
VAR Zaehl:WORD;
BEGIN
  IF NOT AKtiv THEN exit;
  FOR Zaehl:=1 TO AnzLine DO
    DISPOSE(ListArray^[Zaehl]);
  DISPOSE(ListArray);
  Aktiv:=FALSE;
END;

PROCEDURE ListDrawLine(line:WORD);
VAR
    LineS:STRING[80];
    S1,S2:STRING[20];
    tag,monat,jahr,sekunde,minute,stunde:BYTE;
BEGIN
  IF Line<FirstLine THEN exit;
  IF Line<=AnzLine THEN
    WITH ListArray^[Line]^ DO
    BEGIN
      LineS:=StringD(' ',80);
      Move(Absender[1],LineS[2],Length(Absender));
      LineS[9]:='>';
      Move(Rubrik[1],LineS[11],Length(Rubrik)) ;
      Str(nummer,s1);
      s2:=StringD('.',12-Length(rubrik)-Length(s1))+S1;
      Move(S2[1],LineS[12+Length(Rubrik)],Length(s2));
      decode_ixtime(datum,tag,monat,jahr,stunde,minute,sekunde);
      S2:=ConvertByteToString(tag)+'.'+ConvertByteToString(monat)+
          '.'+ConvertByteToString(Jahr)+' '+ConvertByteToString(minute)+
          ':'+ConvertByteToString(Stunde);
      Move(S2[1],LineS[24],length(s2));
      str(groesse,s2);
      Move(s2[1],LineS[38],Length(s2));
      Move(Titel[1],LineS[47],LengtH(titel));
      IF Markiert THEN
        Prints(1,succ(line-firstline),lineS,fBBSListHighlight)
      ELSE
        Prints(1,succ(line-firstline),lineS,fBBSList);
    END
  ELSE
    Prints(1,succ(line-firstline),StringD(' ',80),fBBSList);
END;

PROCEDURE BBSListReDraw;
VAR Zeile:BYTE;Line:WORD;
BEGIN
  Line:=FirstLine;
  FOR Zeile:=1 TO BBSListWinSize DO
  BEGIN
     ListDrawLine(line);
     inc(line);
  END;
END;


PROCEDURE BBSScanList(S :STRING) ;
BEGIN

END; { BBSScanList }

PROCEDURE BBSSCanDir(S		      : STRING);
BEGIN
END; { BBSSCanDir }


(* DieBox-Checkliste ohne BID : 
    3 FB1RCI > KEPLER...222 08.01.97 AMSAT   1404  60 Mir 2Line day=003
    
    5 LU7FQU > MIR........7 08.01.97 AMSAT   2739  90 ( MIR SALUDO DE NAVIDAD
    
    9 F4AHW  > SYSOP....135 08.01.97 FRA     1427 180 Rech. TFWIN.DLL pour FBB7
    
   10 F5MSL  > TECHNIK..154 08.01.97 FRANCA   689  14 Coax GEDELEC 2-350cc _

* MIT BID:

    3 FB1RCI : KEPLER...222 63955_F6KED  AM  1404  60 Mir 2Line daz'003
      
    5 LU7FQU : MIR........7 425-LU7FQU   AM  2739  90 ( MIR SALUDO DE NAVIDAD
    
    9 F4AHW  : SYSOP....135 1963-F4AHW   FR  1427 180 Rech. TFWIN.DLL pour FBB7
    
   10 F5MSL  : TECHNIK..154 9555_HB9IAP  FR   689  14 Coax GEDELEC 2-350cc _
     
*)
CONST DB_ABSENDER_S=7;DB_ABSENDER_E=12;
      DB_RUBRIK_S=16;DB_RUBRIK_E=23;
      DB_NR_S=24;DB_NR_E=27;
      DB_DATUM_S=29;DB_DATUM_E=36;
      DB_BID_S=29;DB_BID_E=40;
      DB_SIZE_S=45;DB_SIZE_E=49;
      DB_LT_S=51;DB_LT_E=53;
      DB_TITLE_S=55;

PROCEDURE BBSScanCheckList(S:STRING);
VAR B:BYTE;absender:STRING[6];tmp:STRING;
    nummer:word;verteiler:string;rubrik:string[8];bid:string[12];
    datum,size:LONGINT;tag,monat,jahr,lt:BYTE;
    TITLE:STRING;
LABEL _BID,_DATUM;
BEGIN
  (* erstmal prfen, ob es berhaupt eine checkliste ist... *)
  IF S[6]<>' ' THEN exit;
  IF S[13]<>' ' THEN exit;
  IF S[14]<>'>' THEN exit;
  IF S[15]<>' ' THEN exit;
  Absender:='';
  Rubrik:='';
  Write(debugfile,1);
  FOR B:=1 to 5 DO
    IF NOT ((S[B]=' ') OR ((S[b]>='0') AND (s[b]<='9'))) THEN
      exit ;
  Write(debugfile,2);
   FOR B:=7 TO 12 DO
    BEGIN
    IF NOT ((S[B]=' ') OR ((S[b]>='0') AND (s[b]<='9'))
            OR  ((S[B]>'A') AND (S[B]<'Z'))) THEN
    exit
    ELSE
      IF S[B]<>' ' THEN Absender:=Absender+S[b] ;
    END;
   Write(debugfile,'3:');WriteLn(debugfile,Absender);
  FOR B:=DB_RUBRIK_S TO DB_RUBRIK_E DO
     IF (S[B]<=#33) OR (S[B]>=#122) OR ((S[B]>=#57) AND (S[B]<=#64)) THEN
       EXIT 
     ELSE
       IF S[B]<>'.' THEN Rubrik:=Rubrik+S[b];
  Write(debugfile,'4:');WriteLn(debugfile,Rubrik);
  tmp:='';     
  FOR B:=DB_NR_S TO DB_NR_E DO
     IF NOT (((S[B]<='9') AND (S[B]>='0')) OR (S[B]='.')) THEN
       EXIT 
     ELSE
       IF S[B]<>'.' THEN tmp:=tmp+S[b];
  VAL(tmp,nummer,err);
  Write(debugfile,'5:');WriteLn(debugfile,nummer);
  tmp:='';
  FOR B:=DB_DATUM_S TO DB_DATUM_E DO
     IF NOT (((S[B]<='9') AND (S[B]>='0')) OR (S[B]='.')) THEN
     BEGIN
        datum:=0; 
        GOTO _BID;
      END
      ELSE
        tmp:=tmp+S[b];
  VAL(copy(tmp,1,2),tag,err);
  VAL(copy(tmp,4,2),monat,err);
  VAL(copy(tmp,7,4),jahr,err);
  tmp:='';
  Write(debugfile,'6:');WriteLn(debugfile,tag,monat,jahr);
  verteiler:=ltrim(copy(S,DB_DATUM_E+2,6));
  Write(debugfile,'7:');WriteLn(debugfile,verteiler);
  GOTO _DATUM;
_BID:
  FOR B:=DB_BID_S TO DB_BID_E DO
     IF NOT (((S[B]<='9') AND (S[B]>='0')) OR (S[B]='.') OR 
        ((S[B]<='Z') AND (S[B]>='A')) OR (S[B]='_') OR (S[B]='-') OR (S[B]=' ')) THEN
     BEGIN
       exit;
     END   
     ELSE IF S[b]<>' '  THEN
       bid:=bid+S[b];
 verteiler:=COPY(S,DB_BID_E+2,2);
 Write(debugfile,'8:');WriteLn(debugfile,verteiler); 
_DATUM:
  FOR B:=DB_SIZE_S TO DB_SIZE_E DO
     IF NOT (((S[B]<='9') AND (S[B]>='0'))  OR (S[B]=' ')) THEN
     BEGIN
       exit;
     END   
     ELSE IF S[b]<>' ' THEN
       tmp:=tmp+S[b]; 
  VAL(tmp,size,err);
  Write(debugfile,'9:');WriteLn(debugfile,size,'(size)'); 
  tmp:='';
  FOR B:=DB_LT_S TO DB_LT_E DO
     IF NOT (((S[B]<='9') AND (S[B]>='0')) OR (S[B]=' ')) THEN
     BEGIN
       exit;
     END   
     ELSE IF S[b]<>' ' THEN
       tmp:=tmp+S[b];
  VAL(tmp,lt,err);
   if err>0 then exit;
  title:=LTRIM(copy(s,DB_TITLE_s,255));
  Write(debugfile,'10:');WriteLn(debugfile,lt); 
  Write(debugfile,'11:');WriteLn(debugfile,title);
   IF ListArray=NIL THEN InitList(0);
   inc(AnzLine);
   new(Listarray^[Anzline]);
   ListArray^[Anzline]^.Rubrik:=Rubrik;
   ListArray^[Anzline]^.Nummer:=Nummer;
   ListArray^[Anzline]^.Titel:=Title;
   ListArray^[Anzline]^.Absender:=Absender;
   ListArray^[Anzline]^.Datum:=Datum;
   ListArray^[Anzline]^.Groesse:=Size;
   ListArray^[Anzline]^.bid:=Bid;
   ListArray^[Anzline]^.Markiert:=FALSE;

END;

PROCEDURE BBSListHandle(VAR S : STRING);
BEGIN
   BBSScanCheckList(S);
   BBSScanList(S);
   BBSScanDir(S);
END;   

PROCEDURE BBSLISTHANDLEKEY;
BEGIN 
  CASE XReadKey OF
    #32	: ;
    #0:CASE XReadKey OF
       KEY_PGDN:
            BEGIN
              inc(Zeile,20);
            END;
       KEY_PGUP:
            BEGIN
              dec(Zeile,20);
            END;         
      KEY_UP: BEGIN
             dec(Zeile);
            END;  
       KEY_DOWN:
            BEGIN
             inc(Zeile);
            END;  
       END;
  END;           
END;
BEGIN
   ListArray:=NIL;
END.
