UNIT mcutbuf;
{ $D+,L+ }
INTERFACE

USES OBJECTS,CRT,TOOLBOX,VIDEO,ANSI;
CONST
   MEM_CONV = 1;
   MEM_XMS  = 2;
   MEM_EMS  = 4;
   MEM_UMB  = 8;
   MEM_FILE =16;
   BufError:BYTE=0;
   AnsiColors:BOOLEAN=TRUE;


TYPE
  charr=ARRAY[1..60000] OF CHAR;
  PMBUF=^TMBUF;
  TMBUF=OBJECT
    {* dies ist ein index auf den ersten string im ringpuffer *}
    erste_zeile_im_puffer,
    {* an dieser stelle wird eingefgt *}
    letzte_zeile_im_puffer,
    {* die zeile, die als erste auf dem bildscirm gezeigt wird *}
    erste_zeile_im_fenster,
    {* dies ist die grsse des puffers *}
    bufsize,
    {* dies ist ein index auf die zeile im puffer,
       die bottom-top zeilen oberhalb von letzte_zeile_im_puffer liegt  *}
    pagetop,
    {* das ist das XMS-Handle *}
    handle:WORD;
    {* dies ist die Position im Stream, wenn EMS oder FILE *}
    PosInStream:LONGINT;
    {* die erste bildschirmzeile *}
    top,
    {* die letzte bildschirm zeile *}
    bottom,
    {* 1 wenn buffer im XMS *}
    status,
    {* 0 buffer im conv ram, 1 im xms *}
    mode,
    defaultcolor:BYTE;
    {* ist der puffer gerade zurckgescrollt *}
    scroll:BOOLEAN;
    {* die letzte zeile, die gerade bearbeitet wird *}
    LastLine,ansirest:STRING;

    {* dies ist der eigentliche puffer *}
    buf:^charr;
    CONSTRUCTOR init(size: WORD; af1, af2, atop, abottom, Use_Which_MEM: BYTE);
    DESTRUCTOR done;
    PROCEDURE InsBufLn(s: STRING);
    PROCEDURE WriteBuf(s: STRING; color: BYTE);
    PROCEDURE DumpBuf(FileName:STRING);
    PROCEDURE ReadFile(FileName:STRING;col:BYTE);
    PROCEDURE ShowBuf;
    PROCEDURE ScrollUp;
    PROCEDURE ScrollDown;
    PROCEDURE PageUp(lines: BYTE);
    PROCEDURE PageDown(lines: BYTE);
    PROCEDURE GoHome;
    PROCEDURE Goend;
    PROCEDURE SwapOut;
    PROCEDURE SwapIn;
    PROCEDURE Resize(a,b:BYTE);
    PROCEDURE Load(VAR F:FILE);
    PROCEDURE Store(VAR F:FILE);
    FUNCTION OverLap(Zeile,Zeile2,len:WORD):BOOLEAN;
    PROCEDURE Zeile_Vor(VAR Zeile:WORD);
    PROCEDURE Zeile_Rueck(VAR Zeile:WORD);
    PROCEDURE Get_Zeile(zeile:WORD;Var S:STRING);
    PROCEDURE Put_Zeile(zeile:WORD;S:STRING);
  END;

PROCEDURE setlin(lin, col: BYTE);
PROCEDURE AllocSwapMem(size:LONGINT);

IMPLEMENTATION
{$IFNDEF FPK}
USES xms,mystring;
{$ENDIF}

CONST breit=80;
      EMSStreamOK:BOOLEAN=FALSE;
      FILEStreamOK:BOOLEAN=FALSE;
      EMSNextFreePos:LONGINT=0;
      FILENextFreePos:LONGINT=0;
      MagicNumber:WORD=29;

VAR
  _cols,_lines:BYTE;
  test:boolean;
  L,R,ein_s:STRING;
  deb1,deb2,deb3,deb4:STRING;
  hlp:BOOLEAN;
  {* Falls EMS oder FILE verwendet wird, dann werden die Buffer
     hier hinein geswappt *}
  {$IFNDEF linux}   
  EMSStream:PEMSStream;
  FILEStream:PDosStream;
  {$ENDIF}
  FileName:STRING[70];
  OldExitProc:POINTER;

PROCEDURE BufExitProc;FAR;
VAR F:File;
BEGIN
  exitproc:=oldexitproc;
  {$IFNDEF linux}
  IF EMSStreamOk THEN
    DISPOSE(EMSStream,Done);
  IF FILEStreamOK THEN
  BEGIN
      DISPOSE(FileStream,Done);
  {$I-}
    ASSIGN(f,filename);erase(f);
    inoutres:=0;
  END;
  {$ENDIF}
END;
{* gibt die richtige lnge eines strings ohne attribute aus *}

{$IFNDEF linux}
FUNCTION TrueLen(VAR S:STRING):BYTE;ASSEMBLER;
ASM
    CLD
    PUSH DS
    MOV BX,0
    LDS SI,S              {Adresse von S nach DS:SI}
    XOR CX,CX
    MOV CL,DS:[SI]        {Lngen-Byte nach CX}
    JCXZ @Fertig
    INC SI                {SI := SI + 1}
   @Schleife:
    MOV AH,DS:[SI]
    INC SI
    CMP AH,0
    JE @NeuAttrib
    INC BX
    LOOP @Schleife
    JMP @fertig
   @NeuAttrib:
    DEC CX
    JCXZ @fertig
    INC SI
   @weiter:
    LOOP @Schleife
   @Fertig:
    MOV AX,BX
    POP DS
END;
{$ELSE}
FUNCTION truelen(s:STRING):BYTE;
VAR len,b:WORD;
BEGIN
  len:=length(s);
  for b:=1 to length(s) DO
    if s[b]=#0 then len:=len-2;
  truelen:=len;
END;  
{$ENDIF}


PROCEDURE setlin(lin,col:BYTE);
BEGIN
  _lines:=lin;
  _cols:=col;
END;

CONSTRUCTOR tmbuf.init(size: WORD; af1, af2, atop, abottom, Use_Which_MEM: BYTE);

VAR w:WORD;buf2:pointer;
BEGIN
  ansirest:='';
  defaultcolor:=af1;
  lastline:='';
  bufsize:=(size * 1024);
  IF maxavail < bufsize THEN
  BEGIN
    Prints(1,1,'out of memory, program aborted',71);
    halt(11);
  END;
  Getmem(buf, bufsize);
  fillchar(buf^, bufsize, 0);
  mode:=0;
  {* IF (mode=0) AND (use_which_mem AND MEM_UMB<>0) THEN
  BEGIN
    IF (UmbGetMem(bufsize,w)>=bufsize) AND (XMSError=0) THEN
    BEGIN
      WriteLn('UMB at segment ',xhex(w));readkey;
      Buf2:=buf;
      buf:=ptr(w,0);
      move(buf2^,buf^,bufsize);
      FreeMem(buf2,bufsize);
      mode:=3
    END;
  END;  *}
  {$IFNDEF linux}
  IF (mode=0) AND (use_which_mem AND MEM_EMS<>0) AND EMSStreamOk THEN
  BEGIN
    EMSStream^.Seek(EMSNextFreePos);
    PosInStream:=EMSNextFreePos;
    EMSStream^.Write(Buf^,BufSize);
    IF EMSStream^.ErrorInfo=0 THEN
    BEGIN
      EMSNextFreePos:=EMSNextFreePos+Bufsize;
      mode:=2;
    END;
  END;  
  IF (mode=0) AND (use_which_mem AND MEM_XMS<>0) THEN
  BEGIN
    IF XMMPresent THEN
    BEGIN
      mode:=1;
      IF XMSMaxAvail < size THEN
        mode:=0
      ELSE
      BEGIN
        handle:=EMBGetMem(size);
        IF XMSError > 0 THEN mode:=0;
      END;
    END 
    ELSE mode:=0;
  END;
  IF (mode=0) AND (use_which_mem AND MEM_FILE<>0) AND FILEStreamOk THEN
  BEGIN
    FILEStream^.Seek(FILENextFreePos);
    PosInStream:=FILENextFreePos;
    FILEStream^.Write(Buf^,BufSize);
    IF FILEStream^.ErrorInfo=0 THEN
    BEGIN
      FILENextFreePos:=FILENextFreePos+Bufsize;
      mode:=4;
    END;
  END; 
  {$ENDIF}
  bottom:=abottom;
  top:=atop;
  status:=0;
  erste_zeile_im_puffer:=3;
  letzte_zeile_im_puffer:=1;
  PageTop:=1;
  FOR W:=1 to (bottom-top) DO
    Zeile_Rueck(Pagetop);
  erste_zeile_im_fenster:=pagetop;
  scroll:=FALSE;
  status:=0;
  SwapOut;
END;             


PROCEDURE tmbuf.zeile_vor(VAR zeile:WORD);
VAR W:WORD;B:WORD;
BEGIN
  W:=Zeile;
  FOR B:=1 TO BYTE(Buf^[zeile])+2 DO
  BEGIN
    inc(W);
    IF W>BufSize THEN
       W:=1;
  END;
  zeile:=W;
END;

PROCEDURE tmbuf.zeile_rueck(VAR zeile:WORD);
VAR W:WORD;B:WORD;
BEGIN
  DEC(Zeile);
  IF Zeile=0 THEN Zeile:=BufSize;
  W:=Zeile;
  FOR B:=1 TO BYTE(Buf^[Zeile])+1 DO
  BEGIN
    DEC(W);
    IF W=0 THEN
       W:=BufSize;
  END;
  zeile:=W;
END;
{*
FUNCTION tmbuf.OverLap(Zeile,b:WORD):BOOLEAN;
VAR W:WORD;
BEGIN
  W:=Zeile;
  OverLap:=FALSE;
  FOR B:=1 TO BYTE(Buf^[zeile])+2 DO
  BEGIN
    IF W=B THEN
    BEGIN
      OverLap:=TRUE;
      EXIT;
    END;
    inc(W);
    IF W>BufSize THEN
       W:=1;
  END;
END;
*}
FUNCTION tmbuf.OverLap(Zeile,Zeile2,len:WORD):BOOLEAN;
VAR W:WORD;B:WORD;
BEGIN
  W:=Zeile;
  OverLap:=FALSE;
  FOR B:=1 TO len+2 DO
  BEGIN
    IF W=Zeile2 THEN
    BEGIN
      OverLap:=TRUE;
      EXIT;
    END;
    inc(W);
    IF W>BufSize THEN
       W:=1;
  END;
END;


PROCEDURE tmbuf.Get_Zeile(zeile:WORD;VAR S:STRING);
VAR W:WORD;B:WORD;
BEGIN
  W:=Zeile;
  FOR B:=0 TO BYTE(Buf^[zeile]) DO
  BEGIN
    S[B]:=Buf^[W];
    inc(W);
    IF W>BufSize THEN
       W:=1;
  END;
END;

PROCEDURE tmbuf.Put_Zeile(zeile:WORD;S:STRING);
VAR W:WORD;B:WORD;
BEGIN
  W:=Zeile;
  FOR B:=0 TO Length(S) DO
  BEGIN
    Buf^[W]:=S[B];
    inc(W);
    IF W>BufSize THEN
       W:=1;
  END;
  Buf^[W]:=S[0];
END;


PROCEDURE tmbuf.InsBufLN(s: STRING);
VAR B:WORD;
BEGIN
   Zeile_Vor(Letzte_Zeile_im_Puffer);
   WHILE Overlap(Letzte_Zeile_Im_puffer,Erste_Zeile_Im_Puffer,Length(S)) DO
      Zeile_Vor(Erste_Zeile_Im_Puffer);
   WHILE Overlap(Letzte_Zeile_Im_puffer,Erste_Zeile_Im_Fenster,Length(S)) DO
      Zeile_Vor(Erste_Zeile_Im_Fenster);
   Put_Zeile(Letzte_Zeile_Im_Puffer,S);
   PageTop:=Letzte_Zeile_Im_Puffer;
   FOR B:=1 TO (Bottom-Top) DO
     Zeile_Rueck(PageTop);
   IF NOT Scroll THEN
     Erste_Zeile_Im_Fenster:=PAGETOP;
END;


PROCEDURE tmbuf.WriteBuf(s: STRING; color: BYTE);
VAR B:word;
    ansilen:WORD;
    ansicol:BYTE;
    grmpf:STRING[2];
    pops:WORD;

  PROCEDURE Pumpen(s:STRING;attr:BYTE);
  VAR merk:WORD;l,s2:string; test:BOOLEAN;
  BEGIN
    inc(pops);{
    if s[1]=#13 THEN
    BEGIN
      test:=find(s,#13,l,s2);
      ClrScr;
      WriteLn(byte(test));
      WriteLn(S);
      WriteLn(l);
      WriteLn(s2);
      READLN;
    END;  }
    WHILE FIND(s,#13,l,s) DO
    BEGIN
      Merk:=TrueLen(LastLine);
      WHILE (TrueLen(l))>(breit-Merk) DO
      BEGIN
        s2:=copy(l,1,breit-merk);
        LastLine:=LastLine+#0+char(attr)+s2;
        insBufLn(lastline);
        LastLine:='';
        l:=copy(l,breit+1-merk,255);
        merk:=0;
      END;
      InsBufLn(LastLine+#0+char(attr)+l);
      LastLine:='';
    END;
    s:=l;
    Merk:=TrueLen(LastLine);
    WHILE (TrueLen(s))>(breit-Merk) DO
    BEGIN
      s2:=copy(s,1,breit-merk);
      LastLine:=LastLine+#0+char(attr)+s2;
      insBufLn(lastline);
      LastLine:='';
      s:=copy(s,breit+1-merk,255);
      merk:=0;
    END;
    LastLine:=LastLine+#0+char(attr)+s;
  END;


BEGIN
  {*
   * erstmal den puffer ins ram laden
   *}
  SwapIn;
  IF status<>0 THEN exit;
  pops:=0;

  IF AnsiColors THEN
  BEGIN
    {*
     * #0 durch spaces ersetzen, weil #0 fr die farbumschaltung gebraucht
     * wird
     *}
    b:=1;
    AnsiLen:=1;
    IF AnsiRest<>'' THEN
    BEGIN
      WHILE (Decode_ANSI(COPY(ansirest+s,b,ansilen),ansicol)=0) AND ((ansilen)<length(ansirest+s)) DO
        INC(ansilen);
      ansicol:=color;
      CASE Decode_ANSI(COPY(ansirest+s,b,ansilen),ansicol) OF
        0:BEGIN
            Pumpen(ansirest,color);
          END;
        1:BEGIN
            delete(s,1,ansilen-length(ansirest));
            grmpf:=#0+char(ansicol);
            insert(grmpf,s,1);
          END;
        2:BEGIN
            Pumpen(ansirest,color);
          END;
  
      END;
      AnsiRest:='';
    END;
    b:=1;
    WHILE b<=length(s) DO
    BEGIN
      ANSILen:=1;
      WHILE (Decode_ANSI(COPY(s,b,ansilen),ansicol)=0) AND ((b+ansilen)<=length(s)) DO
        INC(ansilen);
      ansicol:=color;
      CASE Decode_ANSI(COPY(s,b,ansilen),ansicol) OF
        0:BEGIN
            AnsiRest:=copy(s,b,ansilen);
            s:=copy(s,1,b-1);
            b:=256;
          END;
        1:BEGIN
            delete(s,b,ansilen);
            grmpf:=#0+char(ansicol);
            insert(grmpf,s,b);
            inc(b,2);
          END;
        2:
          BEGIN
            IF s[b]=#0 THEN s[b]:=' ';
            inc(b);
          END;
      END;
    END;
  END;
  {*
   * so, jetzt den string zeile fr zeile in den buffer pumpen
   *}
  Pumpen(S,color);
  SwapOut;
END;


PROCEDURE tmbuf.ShowBuf;
VAR b,attr,c,i:WORD;actloc:WORD;s:STRING;
BEGIN
  SwapIn;
  IF status<>0 THEN exit;
  actloc:=erste_zeile_im_fenster;
  IF NOT SCROLL THEN
  BEGIN
     Zeile_Vor(actloc);
 (*    IF LastLine<>'' THEN
	Zeile_Vor(actloc);*)
  END;
  FOR b:=1 TO (bottom - top)+1 DO
  BEGIN
    c:=0;
    Get_Zeile(actloc,S);
    WriteAttribString(1,b+top-1,s,defaultcolor);
    IF (actloc=Letzte_Zeile_im_Puffer) AND (B<(bottom-top)+1) (*AND (LastLine<>'')*) THEN
    BEGIN
      WriteAttribString(1,b+top,'  ',defaultcolor);
      WriteAttribString(1,b+top,lastline,defaultcolor);
      SwapOut;
       exit;
    END;
    Zeile_Vor(actloc);
  END;
  SwapOut;
END;


PROCEDURE tmbuf.resize(a,b:byte);
var c:byte;
BEGIN
  top:=a;bottom:=b;
  SwapIn;
  IF status<>0 THEN exit;
  pagetop:=letzte_zeile_im_puffer;
  FOR c:=1 to (b-a) DO
    Zeile_Rueck(PageTop);
  showbuf;
  erste_zeile_im_fenster:=pagetop;
END;

DESTRUCTOR tmbuf.done;
BEGIN
  IF (status = 0) AND (mode<>3) THEN
    freemem(buf, bufsize);
{$IFNDEF linux}
  CASE mode OF
    1:EMBFreeMem(Handle);
    3:UMBFreeMem(Seg(buf));
  END;
{$ENDIF}
END;

PROCEDURE tmbuf.SwapOut;
BEGIN
  {$IFNDEF linux}
  IF Status<>0 THEN exit;
  CASE mode OF
    0:{Ist im Normalen speicher -> nix tun};
    1:{Ist im XMS....}
      BEGIN
        MoveToEMB(buf^,Handle,Bufsize);
        FreeMem(buf,BufSize);
        Buf:=NIL;
        Status:=1;
      END;
    2:{Ist im EMS... }
      BEGIN
        EMSStream^.Seek(PosInStream);
        IF EMSStream^.ErrorInfo<>0 THEN exit;
        EMSStream^.Write(buf^,BufSize);
        IF EMSStream^.ErrorInfo<>0 THEN exit;
        FreeMem(Buf,BufSize);
        Buf:=NIL;
        Status:=1;
      END;
    3:{Ist im UMB...-> nichts tun};
    4:{Ist im DiskFile... }
      BEGIN
        FILEStream^.Seek(PosInStream);
        IF FILEStream^.ErrorInfo<>0 THEN exit;
        FILEStream^.Write(buf^,BufSize);
        IF FILEStream^.ErrorInfo<>0 THEN exit;
        FreeMem(Buf,BufSize);
        Buf:=NIL;
        Status:=1;
      END;
  ELSE Write(#7)
  END;
  {$ENDIF}
END;


PROCEDURE tmbuf.SwapIn;
{$IFNDEF linux}
FUNCTION GetBuf:BOOLEAN;
BEGIN
  GetBuf:=TRUE;
  IF maxavail < bufsize THEN
  BEGIN
    GetBuf:=FALSE;
  END
  ELSE
    Getmem(buf, bufsize);
END;

BEGIN
  IF Status<>1 THEN exit;
  CASE mode OF
    0:{Ist im Normalen speicher -> nix tun};
    1:{Ist im XMS....}
      BEGIN
        IF NOT GetBuf THEN Exit;
        MoveFromEMB(Handle,buf^,Bufsize);
        Status:=0;
      END;
    2:{Ist im EMS... }
      BEGIN
        IF NOT GetBuf THEN Exit;
        Status:=0;
        EMSStream^.Seek(PosInStream);
        IF EMSStream^.ErrorInfo<>0 THEN exit;
        EMSStream^.Read(buf^,BufSize);
        IF EMSStream^.ErrorInfo<>0 THEN exit;
      END;
    3:{Ist im UMB...-> nichts tun};
    4:{Ist im DiskFile... }
      BEGIN
        IF NOT GetBuf THEN Exit;
        Status:=0;
        FILEStream^.Seek(PosInStream);
        IF FILEStream^.ErrorInfo<>0 THEN exit;
        FILEStream^.Read(buf^,BufSize);
        IF FILEStream^.ErrorInfo<>0 THEN exit;
      END;
  ELSE Write(#7)
  END;
{$ELSE} BEGIN
{$ENDIF}
END;

PROCEDURE tmbuf.ScrollUp;
BEGIN
  IF erste_zeile_im_fenster <> erste_zeile_im_puffer THEN
  BEGIN
    SwapIn;
    Zeile_Rueck(erste_Zeile_Im_Fenster);
    scroll:=TRUE;                      {if mode=1 then status:=2;}
    showbuf;
  END;
END;


PROCEDURE tmbuf.ScrollDown;
BEGIN
  IF erste_zeile_im_fenster <> pagetop THEN
  BEGIN
    SwapIn;
    Zeile_Vor(erste_zeile_im_fenster);
    IF erste_zeile_im_fenster = pagetop THEN
    BEGIN
      scroll:=FALSE;
      IF status = 2 THEN status:=0;
    END;
    showbuf;
  END;
END;


PROCEDURE TMbuf.PageUp(lines: BYTE);
VAR b:BYTE;
BEGIN
  SwapIn;
  IF status<>0 THEN exit;
  IF NOT Scroll THEN DEC(lines);
  FOR b:=1 TO lines DO
    IF (erste_zeile_im_fenster<>erste_zeile_im_puffer) THEN
      Zeile_Rueck(erste_zeile_im_fenster);
  scroll:=TRUE;
  showbuf;
END;

PROCEDURE tmbuf.PageDown(lines: BYTE);
VAR b:BYTE;
BEGIN
  SwapIn;
  IF status<>0 THEN exit;
  FOR b:=1 TO lines DO
    IF erste_zeile_im_fenster <> pagetop THEN
      Zeile_Vor(erste_zeile_im_fenster);
  IF erste_zeile_im_fenster = pagetop THEN
    scroll:=FALSE;
  showbuf;
END;

PROCEDURE tmbuf.Gohome;
BEGIN
  SwapIn;
  IF status<>0 THEN exit;
  erste_zeile_im_fenster:=erste_zeile_im_puffer;
  scroll:=TRUE;
  status:=2;
  showbuf;
END;

PROCEDURE tmbuf.Goend;
BEGIN
  SwapIn;
  erste_zeile_im_fenster:=pagetop;
  scroll:=FALSE;
  IF status = 2 THEN status:=0;
  showbuf;
END;


PROCEDURE TMBuf.Store(VAR F:FILE);
BEGIN
  {$I-}
  BlockWrite(f,MagicNumber,2);
  BlockWrite(f,BufSize,2);
  BlockWrite(f,erste_zeile_im_puffer,2);
  BlockWrite(f,letzte_zeile_im_puffer,2);
  BlockWrite(f,erste_zeile_im_fenster,2);
  BlockWrite(f,pagetop,2);
  BlockWrite(f,scroll,1);
  BlockWrite(f,lastline[0],256);
  BlockWrite(f,ansirest[0],256);
  SwapIn;
  BlockWrite(f,Buf^,BufSize);
  SwapOut;
END;

PROCEDURE TMBuf.Load(VAR F:FILE);
VAR Vergleich:WORD;
BEGIN
  BufError:=1;
  BlockRead(F,Vergleich,2);
  IF Vergleich<>MagicNumber THEN Exit;
  BlockRead(F,Vergleich,2);
  IF Vergleich<>BufSize THEN Exit;
  BlockRead(f,erste_zeile_im_puffer,2);
  BlockRead(f,letzte_zeile_im_puffer,2);
  BlockRead(f,erste_zeile_im_fenster,2);
  BlockRead(f,pagetop,2);
  BlockRead(f,scroll,1);
  BlockRead(f,lastline[0],256);
  BlockRead(f,ansirest[0],256);
  SwapIn;
  BlockRead(f,Buf^,Bufsize);
  SwapOut;
  IF IORESULT=0 THEN BufError:=0;
END;

PROCEDURE AllocSwapMem(size:LONGINT);
BEGIN
   {$IFNDEF linux}
  EMSStream:=NEW(PEMSStream,Init(size,size));
  IF (EMSStream<>NIL) AND (EMSSTream^.ErrorInfo=0) THEN
    EMSStreamOK:=TRUE;
  FILEStream:=NEW(PDosStream,Init('BUFSWAP.MCT',StCreate));
  IF (FILEStream<>NIL) AND (FILEStream^.ErrorInfo=0) THEN
    FILESTreamOK:=TRUE;
  {$ENDIF}  
END;

PROCEDURE TMBUF.DumpBuf(FileName:STRING);
VAR F:TEXT;
    p:WORD;
    S:STRING;
    B:BYTE;
BEGIN
  Assign(f,filename);
  Rewrite(f);
  If ioresult<>0 then exit;
  Swapin;
  P:=erste_zeile_im_puffer;
  REPEAT
    Get_Zeile(p,s);
    While Pos(#0,s)>0 DO DELETE(s,pos(#0,s),2);
    WriteLn(f,s);
    IF p<>Letzte_Zeile_im_Puffer THEN
      Zeile_Vor(P);
  UNTIL P=Letzte_Zeile_im_Puffer;
  CLOSE(F);
  SwapOut;
END;

PROCEDURE TMBUF.ReadFile(FileName:STRING;col:BYTE);
VAR F:TEXT;
    p:WORD;
    S:STRING;
    B:BYTE;
BEGIN
  Assign(f,filename);
  Reset(f);
  If ioresult<>0 then exit;
  Swapin;
  While Not EOF(F) DO
  BEGIN
    ReadLn(f,s);
    WriteBuf(s+#13,col);
  END;
  CLOSE(F);
  SwapOut;
END;



BEGIN
 OldExitProc:=ExitProc;
  ExitProc:=@BufExitProc;
END.
